
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;
import java.util.Vector;

import com.mysql.jdbc.Statement;


public class DefragmentAllocations2 implements Runnable
{
	Thread t;
	int[][] tempBitMap=new int [48][500];
	Vector<Integer> tempSummaryVector = new Vector<Integer>();
	SlotReservation userPL = new SlotReservation();
	int currentSlot = 0;

	DefragmentAllocations2(SlotReservation userPL2)
	{
		userPL = userPL2;
		resetBitMap(tempBitMap);
		t = new Thread(this);
		System.out.println("Defragmentation2 Thread has been started");
		t.start();
	}
	
	public DefragmentAllocations2() 
	{
		System.out.println("Method 2");
	}
	
	public void defragmentBitMapMethod2(ArrayList<slotInfo> defragList)
	{

		Vector<Integer> timeSlotsOccupied = new Vector<Integer>();
		FreeSpaceDetection xMan = new FreeSpaceDetection();
		 ArrayList<slotInfo>  defragList2 = new ArrayList<slotInfo>();  
			defragList2 = new ArrayList<slotInfo>();

		int arrayListSize = defragList.size();

        String currentStartTimeString = "";
        String currentStopTimeString = "";
       // String currentcarRegnumString = "";

        if(arrayListSize!=0)
        {
            //Insert defragList elements into the bitMap while deleting their old positions
        	System.out.println("Array LIst Size = "+arrayListSize);
        	System.out.println("dxefrag list is "+ userPL.defragList);
        	
	       	 for(int i=0; i<arrayListSize; i++)
	       	 {
	       		 slotInfo currentObject = null;
	        	 currentObject = defragList.get(i);
	        	 currentStartTimeString = getStartTime(currentObject); 
	            int currentStartTimeInt = Integer.parseInt(currentStartTimeString.trim());
	            currentStopTimeString = getStopTime(currentObject); 
	            int currentStopTimeInt = Integer.parseInt(currentStopTimeString.trim());
	            //currentcarRegnumString = getcarRegnum(currentObject);
	           // int currentcarRegnumInt = Integer.parseInt(currentcarRegnumString.trim());
	            int getRealStartTime = convertToTime(currentStartTimeInt,0);
                int getRealStopTime = convertToTime(currentStopTimeInt,1);
                
                //System.out.println("Temp BM =");
				//printBitMap(tempBitMap);

	            timeSlotsOccupied = xMan.calculateTimeSlots(getRealStartTime, getRealStopTime);
	            System.out.println("timeSlotsOccupied="+timeSlotsOccupied);
	            int slotPassed = reAllotSlot(timeSlotsOccupied, currentObject, defragList2);
	            insertBitMap(tempBitMap,timeSlotsOccupied,slotPassed);
	       	 }
	       	 System.out.println("$$$The final Vector reads as "+defragList2);
	       	 System.out.println("The final tempBitmAp is ");
				//printBitMap(tempBitMap);

        }
	}
	
	public void insertBitMap(int[][] bitMap,Vector<Integer> timeSlotsOccupied, int slotNumber)
	{
		
		for(int time=0;time<48;time++)
		{
			for(int slot=0;slot<500;slot++)
			{
				if (slot==slotNumber)
				{
					if(timeSlotsOccupied.size()>0)
					{
						if(time==timeSlotsOccupied.get(0))
						{							
							timeSlotsOccupied.get(0);
							timeSlotsOccupied.remove(0);
							bitMap[time][slot] = 1;

						}

					}
				}
			}
		}
		//System.out.println("Inserted Bitmap is ");
		//printBitMap(bitMap);

		
	}
	
	public void resetBitMap(int[][] bitMap)
	{
		for (int time=0;time<48;time++)
		{
			for(int slot=0;slot<500;slot++)
			{
				bitMap[time][slot]=0;
			}
		}
	}
	
	public static String getStopTime(slotInfo o)
	{
		return o.stopTime;
	}
	
	public static String getStartTime(slotInfo o)
	{
		return o.startTime;
	}
	
	public static String getcarRegnum(slotInfo o)
	{
		return o.carRegnum;
	}
	
	public static String getCarSlot(slotInfo o)
	{
		return o.slot;
	}
	
	public void printBitMap(int[][] bitMap)
	{
		for (int time=0;time<48;time++)
		{
			for(int slot=0;slot<500;slot++)
			{
				System.out.print("  "+bitMap[time][slot]);
			}
			System.out.println("");
		}
	}
	
	public int convertToTime(int timeSlot, int indicator)
	{
		int time = 0;
		
		time = timeSlot*50;
		
		if(indicator == 0)
			return time;
		else 
			return time+50;
		
	}
	
	public void run() 
	{
		System.out.println("In Run");
		
		try 
		{
			Thread.sleep(1780000);
		} 
		catch (InterruptedException e1) 
		{
			e1.printStackTrace();
		}
		
		//Defragmenting the reservation BitMap

		int size1 = userPL.defragList.size();
		if(size1!=0)
		{	
			System.out.println("***************BEFORE CANCELLATION BM IS *******************");
			printBitMap(userPL.bitMap);
			
			for(int k = 0;k<263;k++)
			{
				int index = generate_random(0,1300);
				cancelReservation(userPL.defragList,index);
			}
			updateBitMap(userPL.defragList);
			System.out.println("***************AFTER CANCELLATION BM IS *******************");
			printBitMap(tempBitMap);

			calculateLinkSize(tempBitMap,0);

				    
			int highestSlot = getHighestSlot(0);
			System.out.println("The highest slot after cancellation is "+highestSlot);
			
			int beforeZeros = countZeros(highestSlot);
			int packedZeros = countZeros1(highestSlot);
			System.out.println("Number of zeros after cancellation "+beforeZeros);
			accessDatabase(beforeZeros,0);
			accessDatabase(packedZeros,2);
			accessDatabase(highestSlot,10);

			resetBitMap(tempBitMap);

			defragmentBitMapMethod2(userPL.defragList);    
			
			highestSlot = getHighestSlot(1);
			System.out.println("The highest slot after defragmentation is "+highestSlot);
			int afterZeros = countZeros(highestSlot);
			int packedZeros1 = countZeros1(highestSlot);
			System.out.println("Number of zeros after cancellation "+afterZeros);
			accessDatabase(afterZeros,1);
			accessDatabase(packedZeros1,3);
			accessDatabase(highestSlot,11);
			//Saving the defragged bitMap as the final bitMap
        
			resetBitMap(userPL.bitMap);
			userPL.bitMap = tempBitMap;
			System.out.println("THE FINAL ONE IN METHOD 2 IS ");
			printBitMap(userPL.bitMap);
			calculateLinkSize(userPL.bitMap,1);

        //Saving the defragged reservations Summary Vector as the final Summary Vector
        
			userPL.summaryVector.clear();
			int size =  tempSummaryVector.size();
        
	        for(int i = 0; i<size; i++)
	        	userPL.summaryVector.add(0);
	        
	        Collections.copy(userPL.summaryVector,tempSummaryVector);
			}
	
	}

	public void cancelReservation(ArrayList<slotInfo> defragList, int index)
	{
		defragList.remove(index);
		//defragList.remove(0);
	}
	
	public void updateBitMap(ArrayList<slotInfo> defragList)
	{

		Vector<Integer> timeSlotsOccupied = new Vector<Integer>();
		FreeSpaceDetection xMan = new FreeSpaceDetection();

		int arrayListSize = defragList.size();

		String currentStartTimeString = "";
        String currentStopTimeString = "";
        String currentcarSlotString = "";

        if(arrayListSize!=0)
        {
            //Insert defragList elements into the bitMap while deleting their old positions
        	System.out.println("Array LIst Size = "+arrayListSize);
        	System.out.println("dxefrag list is "+ userPL.defragList);
        	
	       	 for(int i=0; i<arrayListSize; i++)
	       	 { 
	       		 slotInfo currentObject = null;
	        	 currentObject = defragList.get(i);
	        	 currentStartTimeString = getStartTime(currentObject); 
	            int currentStartTimeInt = Integer.parseInt(currentStartTimeString.trim());
	            currentStopTimeString = getStopTime(currentObject); 
	            int currentStopTimeInt = Integer.parseInt(currentStopTimeString.trim());
	            currentcarSlotString = getCarSlot(currentObject);
	            int currentcarSlotInt = Integer.parseInt(currentcarSlotString);
	           // currentcarRegnumString = getcarRegnum(currentObject);
	            //int currentcarRegnumInt = Integer.parseInt(currentcarRegnumString.trim());
	            int getRealStartTime = convertToTime(currentStartTimeInt,0);
                int getRealStopTime = convertToTime(currentStopTimeInt,1);
                
                //System.out.println("Temp BM =");
				//printBitMap(tempBitMap);

	            timeSlotsOccupied = xMan.calculateTimeSlots(getRealStartTime, getRealStopTime);
	            //System.out.println("timeSlotsOccupied="+timeSlotsOccupied);
	            //int slotPassed = reAllotSlot(timeSlotsOccupied, currentObject, defragList2);
	            insertBitMap(tempBitMap,timeSlotsOccupied,currentcarSlotInt);
	       	 }
        }

	}
	
	public int reAllotSlot(Vector<Integer> checkTimeSlots,slotInfo obj, ArrayList<slotInfo>  defragList2) 
	{
		
		//System.out.println("The passed vector is "+checkTimeSlots);
		int parkingSlot = 0;
		int slot = 0;
		int startIndex = 0;
		int stopIndex = 0;
		int vectorSize = 0;
		int timeSlotCount = 0;
		boolean foundSlot = false;
		
		vectorSize = checkTimeSlots.size();
		startIndex = checkTimeSlots.get(0);
		stopIndex = checkTimeSlots.get(vectorSize - 1);
		timeSlotCount = stopIndex - startIndex + 1;
		
		String carRegnum = getcarRegnum(obj);
	    String regnumString = carRegnum;
	    String startIndexString = Integer.toString(startIndex);
	    String stopIndexString = Integer.toString(stopIndex);
 
		while(slot < 500)
		{
			int tempCount = 0;
			boolean foundOverlap = false;

			for(int time = startIndex; time<=stopIndex; time++)
			{				
				if (tempBitMap[time][slot] == 1)
				{
					foundOverlap = true;
					break;
				}
				
				else
				{					
					tempCount = tempCount + 1;
					continue;
				}
					
					
			}
			if (foundOverlap == true)
			{
				slot++;
			}
					
			if(tempCount == timeSlotCount)
			{
				parkingSlot = slot;
				foundSlot = true;
				break;
			}
			else
				continue;
		}
		
		if(foundSlot == true)
		{
			String parkingSlotString = Integer.toString(parkingSlot);
			slotInfo user = new slotInfo(regnumString,stopIndexString, startIndexString,parkingSlotString);  
		    defragList2.add(user);  
			return parkingSlot;
		}
		else
			return 1000;
	}

	public int countZeros(int highestSlot)
	{
		int zeros = 0;
		
		for(int slot = 0; slot<=highestSlot; slot++ )
		{
			for(int time = 0; time<48; time++)
			{
				if(tempBitMap[time][slot] == 0)
					zeros = zeros + 1;
				
			}
		}
		return zeros;
	}

	public void accessDatabase(int numberOfZeros, int index)
{
		
		Connection conn = null;

        try
        {									

            String userName = "root";
            String password = "";
            String url = "jdbc:mysql://localhost/parkalot_system";
            Class.forName ("com.mysql.jdbc.Driver").newInstance ();
            conn = DriverManager.getConnection (url, userName, password);
        }
        catch (Exception e)
        {
            System.err.println ("Cannot connect to database server");
        }
        finally
        {
            if (conn != null)
            { 
               Statement stmt = null;
               try
               {
            	   stmt = (Statement) conn.createStatement();
            	   if(index == 0)
            		   stmt.executeUpdate("UPDATE fsbm_data set beforeZeros ="+numberOfZeros+" WHERE car_regnum=10000");
            	   else if (index == 1)
            		   stmt.executeUpdate("UPDATE fsbm_data set afterZeros ="+numberOfZeros+" WHERE car_regnum=10000");
            	   else if (index == 2)
            		   stmt.executeUpdate("UPDATE fsbm_data set beforePacked ="+numberOfZeros+" WHERE car_regnum=10000");
            	   else if (index == 3)
            		   stmt.executeUpdate("UPDATE fsbm_data set afterPacked ="+numberOfZeros+" WHERE car_regnum=10000");
            	   else if (index == 10)
            		   stmt.executeUpdate("UPDATE fsbm_data set highSlot1 ="+(numberOfZeros+1)+" WHERE car_regnum=10000");
            	   else if (index == 11)
            		   stmt.executeUpdate("UPDATE fsbm_data set highSlot2 ="+(numberOfZeros+1)+" WHERE car_regnum=10000");

               }
               catch (SQLException e1)
               {
					e1.printStackTrace();
               }
            }
        }
	}

	public int getHighestSlot(int index)
	{
		int highestSlot = 0;
		int [][]currentBitMap = new int[48][500];
		
		if(index == 0)
			currentBitMap = userPL.bitMap;
		else
			currentBitMap = tempBitMap;
		for(int slot = 0; slot<500; slot++ )
		{
			for(int time = 0; time<48; time++)
			{
				if(currentBitMap[time][slot] == 1)
					highestSlot = slot;
				
			}
			
		}
		return highestSlot;
	}

	public int generate_random(int start, int range)
	{
	 	Random generator = new Random();
	    int r = generator.nextInt(range) + start;
	    return (r);
	}
	

	public int countZeros1(int highestSlot)
	{
		int zeros = 0;
		int slot = 0;
		int lastOne = 0;
		
		for(slot = 0; slot<highestSlot; slot++ )
		{
			for(int time = 0; time<48; time++)
			{
				if(tempBitMap[time][slot] == 0)
					zeros = zeros + 1;
				
			} 
		}
		
		for(int time = 0; time<48 ; time++)
			if(tempBitMap[time][slot] == 1)
				lastOne = time;
		
		for(int time = 0; time<=lastOne ; time++)
			if(tempBitMap[time][slot] == 0)
				zeros = zeros + 1;
		
		return zeros;
	}



	public void calculateLinkSize(int[][] tempBitMap2, int index) 
	{
		int count = 0;
		int countOne = 0;
		int insert = 0;
		  
		FileWriter fstream = null;
		try 
		
		{
			if(index == 0)
				fstream = new FileWriter("C:/Users/The Rao/Desktop/predefrag.txt");
			else
				fstream = new FileWriter("C:/Users/The Rao/Desktop/postdefrag.txt");
			
		}
		
		catch (IOException e1) 
		{
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		BufferedWriter out = new BufferedWriter(fstream);
		for(int slot = 0; slot<500; slot++)
		{
			for(int time = 0;time <48; time++)
			{
				if(tempBitMap2[time][slot] == 0)
				{
					count++;
					countOne = 0;
					if(time == 47)
					{
						System.out.println(slot+ " "+count);
									  // Create file 
							
						  try 
						  {
							out.write(slot+ " "+count);
							 out.newLine();
							  //Close the output stream

						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						 					  
						count = 0;
					}
				}
				else 
				{
					countOne++;
					if(count != 48 && countOne == 1)
					{
						System.out.println("At Slot = "+slot+ " Link Length = "+count);
						try{
							  // Create file 
							  //FileWriter fstream = new FileWriter("gandalf.txt");
							  //BufferedWriter out = new BufferedWriter(fstream);
							  out.write(slot+ " "+count);
							  out.newLine();
							  //Close the output stream
							  
							  }catch (Exception e){//Catch exception if any
							  System.err.println("Error: " + e.getMessage());
							  }
						count = 0;
						insert = 1;
					}
					
					continue;
				}
					
			}
			//if(insert == 0 && count != 0 )
			//{
				//System.out.println("At Slot = "+slot+ " Link Length = "+count);
				//count = 0;
		//	}

		}
		try {
			out.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	

	}

}

