import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;
import java.util.Vector;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import com.mysql.jdbc.Statement;

public class DefragmentAllocations3 implements Runnable
{
	Thread t;
	int[][] tempBitMap=new int [48][500];
	int[][] tempaBitMap=new int [48][500];
	Vector<Integer> tempSummaryVector = new Vector<Integer>();
	Vector<Integer> tempaSummaryVector = new Vector<Integer>();
	Vector<Integer> freeSpaceVector = new Vector<Integer>();
	SlotReservation userPL = new SlotReservation();
	int currentSlot = 0;

	DefragmentAllocations3(SlotReservation userPL2)
	{
		userPL = userPL2;
		resetBitMap(tempBitMap);
		t = new Thread(this);
		t.start();
	}
	
	DefragmentAllocations3()
	{
	}
	
	public void defragmentBitMapMethod3(ArrayList<slotInfo> defragList, int index)
	{
		int arrayListSize = defragList.size();
        String currentStartTimeString = "";
        String currentStopTimeString = ""; 
        String currentcarRegnumString = "";
        String currentSlotString = "";
        

        if(arrayListSize!=0)
        {
            
        	//Insert defragList elements into the bitMap while deleting their old positions
        	
        	if(index ==0)
        	{
	       	 for(int i=0; i<arrayListSize; i++)
	       	 {
	       	
	       		slotInfo currentObject = null;
	        	currentObject = defragList.get(i);

	        	System.out.println("CurrentObject == "+currentObject);
	        	
	        	currentStartTimeString = getStartTime(currentObject); 
	            int currentStartTimeInt = Integer.parseInt(currentStartTimeString.trim());
	            
	            currentStopTimeString = getStopTime(currentObject); 
	            int currentStopTimeInt = Integer.parseInt(currentStopTimeString.trim());
	            
	            currentcarRegnumString = getcarRegnum(currentObject);
	            int currentcarRegnumInt = Integer.parseInt(currentcarRegnumString.trim());
	            
	            currentSlotString = getCarSlot(currentObject);
	            int currentSlotInt = Integer.parseInt(currentSlotString.trim());

	            scanAndAllotFreeSpaceVector(currentStartTimeInt,currentStopTimeInt,currentcarRegnumInt,currentSlotInt);	       	 
	       	 }
        	}
        	
        	else
        	{
        	   	 for(int i=arrayListSize-1; i>=0; i--)
    	       	 {
    	       	
    	       		slotInfo currentObject = null;
    	        	currentObject = defragList.get(i);
    	        	
    	        	currentStartTimeString = getStartTime(currentObject); 
    	            int currentStartTimeInt = Integer.parseInt(currentStartTimeString.trim());
    	            
    	            currentStopTimeString = getStopTime(currentObject); 
    	            int currentStopTimeInt = Integer.parseInt(currentStopTimeString.trim());
    	            
    	            currentcarRegnumString = getcarRegnum(currentObject);
    	            int currentcarRegnumInt = Integer.parseInt(currentcarRegnumString.trim());
    	            
    	            currentSlotString = getCarSlot(currentObject);
    	            int currentSlotInt = Integer.parseInt(currentSlotString.trim());

    	            scanAndAllotFreeSpaceVector(currentStartTimeInt,currentStopTimeInt,currentcarRegnumInt,currentSlotInt);
    	       	 
    	       	 }
        	}
        }
	}
	
	public void insertBitMap(int[][] bitMap,Vector<Integer> timeSlotsOccupied, int slotNumber)
	{
		
		for(int time=0;time<48;time++)
		{
			for(int slot=0;slot<500;slot++)
			{
				if (slot==slotNumber)
				{
					if(timeSlotsOccupied.size()>0)
					{
						if(time==timeSlotsOccupied.get(0))
						{							
							timeSlotsOccupied.get(0);
							timeSlotsOccupied.remove(0);
							bitMap[time][slot] = 1;

						}

					}
				}
			}
		}		
	}
	
	public void insertBitMap2(int startTime, int stopTime, int oldSlot, int newSlot)
	{
		for(int i = 0; i< 500 ; i++)
		{
			for(int j = startTime;j<= stopTime ;j++)
			{
				if(i == newSlot)
					tempaBitMap[j][i] = 1;
				
				if(i == oldSlot)
					tempaBitMap[j][i] = 0;
			}
		}

	}
	
	public void resetBitMap(int[][] bitMap)
	{
		for (int time=0;time<48;time++)
		{
			for(int slot=0;slot<500;slot++)
			{
				bitMap[time][slot]=0;
			}
		}
	}
	
	public static String getStopTime(slotInfo o)
	{
		return o.stopTime;
	}
	
	public static String getStartTime(slotInfo o)
	{
		return o.startTime;
	}
	
	public static String getcarRegnum(slotInfo o)
	{
		return o.carRegnum;
	}
	
	public static String getCarSlot(slotInfo o)
	{
		return o.slot;
	}
	
	public void printBitMap(int[][] bitMap)
	{
		for (int time=0;time<48;time++)
		{
			for(int slot=0;slot<500;slot++)
			{
				System.out.print("  "+bitMap[time][slot]);
			}
			System.out.println("");
		}
	}
	
	public int convertToTime(int timeSlot, int indicator)
	{
		int time = 0;
		
		time = timeSlot*50;
		
		if(indicator == 0)
			return time;
		else 
			return time+50;
		
	}
	
	public void run() 
	{		
		try 
		{
			Thread.sleep(1800000);
		} 
		catch (InterruptedException e1) 
		{
			e1.printStackTrace();
		}
		
		generateFreeSpaceVector(0);
		
		//Defragmenting the reservation BitMap

		int size1 = userPL.defragList.size();
		if(size1!=0)
		{	
			for(int k = 0;k<263;k++)
			{
				
				int arrayListSize = userPL.defragList.size();

		        String currentStartTimeString = "";
		        String currentStopTimeString = ""; 
		        String currentSlotString = "";

		        if(arrayListSize!=0)
		        {
		            //Insert defragList elements into the bitMap while deleting their old positions
	        	      	 
		       		slotInfo currentObject = null;
		        	currentObject = userPL.defragList.get(0);
		        	
		        	currentStartTimeString = getStartTime(currentObject); 
		            int currentStartTimeInt = Integer.parseInt(currentStartTimeString.trim());
		           
		            currentStopTimeString = getStopTime(currentObject); 
		            int currentStopTimeInt = Integer.parseInt(currentStopTimeString.trim());
		            
		            currentSlotString = getCarSlot(currentObject);
		            int currentSlotInt = Integer.parseInt(currentSlotString.trim());
		       	 
		            int index = generate_random(0,1300);
					cancelReservation(userPL.defragList, index);
					
					reArrangeFreeSpaceVector(currentStartTimeInt, currentStopTimeInt, currentSlotInt);       //Updating FreeSpace Vector

		        }
							
			}
			generateBitMap(userPL.defragList);
			
			freeSpaceVector.clear();
			generateFreeSpaceVector(2);
			
			
			System.out.println("################After cancellations this is the bitmap##################");
			printBitMap(tempaBitMap);
			calculateLinkSize(tempaBitMap,0);
			int highSlot = getHighestSlot(1);
			int zeros = countZeros(highSlot);
			int packedZeros = countZeros1(highSlot);

			System.out.println("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$The highest Slot is "+highSlot);
			System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%The number of zeros is "+zeros);
			System.out.println("%%%%$$$$The number of packed zeros is "+packedZeros);

			accessDatabase1(zeros,0);
			accessDatabase1(packedZeros,2);
			accessDatabase1(highSlot,10);


			System.out.println("After cancellations this is the FSV######"+freeSpaceVector);
			
			defragmentBitMapMethod3(userPL.defragList,0);
			
			System.out.println("%%%%%%%%%%%%%%Summary Vector now is %%%%%%%%%%%%%%%%%%%%%%%%%%%%%"+tempaSummaryVector);
			System.out.println("################After one defrag this is the bitmap##################");
			
			int highSlot1 = getHighestSlot(1);
			int zeros1 = countZeros(highSlot1);
			int packedZeros1 = countZeros1(highSlot1);
			
			System.out.println("$$$%%%%%The highest Slot1 is "+highSlot1);
			System.out.println("%%%%$$$$The number of zeros1 is "+zeros1);
			System.out.println("%%%%$$$$The number of packed zeros1 is "+packedZeros1);
			printBitMap(tempaBitMap);

			ArrayList<slotInfo> newDefragList = new ArrayList<slotInfo>();
	        newDefragList = generateNewDefragList();
	        //System.out.println("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
			defragmentBitMapMethod3(newDefragList,0);
			System.out.println("################After two defrags this is the bitmap##################");
			printBitMap(tempaBitMap);
			calculateLinkSize(tempaBitMap,1);
			System.out.println(newDefragList);
			//System.out.println("%%%%%%%%%%%%%%Summary Vector now is %%%%%%%%%%%%%%%%%%%%%%%%%%%%%"+tempaSummaryVector);
			int highSlot2 = getHighestSlot(1);
			int zeros2 = countZeros(highSlot2);
			int packedZeros2 = countZeros1(highSlot2);
			accessDatabase1(zeros2,1);
			accessDatabase1(packedZeros2,3);
			accessDatabase1(highSlot2,11);

			System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%The highest Slot2 is "+highSlot2);
			System.out.println("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$The number of zeros2 is "+zeros2);
			System.out.println("%%%%$$$$The number of packed zeros2 is "+packedZeros2);
			
			

			resetBitMap(userPL.bitMap);
			userPL.bitMap = tempaBitMap;
			        
			//Saving the defragged reservations Summary Vector as the final Summary Vector
        
			userPL.summaryVector.clear();
			int size =  tempaSummaryVector.size();
        
			    
			for(int i = 0; i<size; i++)
	        	userPL.summaryVector.add(0);
	        
	        Collections.copy(userPL.summaryVector,tempaSummaryVector);
	               
	        //resetBitMap(tempBitMap);

		}
	
	}

	public void generateBitMap(ArrayList<slotInfo> defragList) 
	{

			int arrayListSize = defragList.size();
			
	        String currentStartTimeString = "";
	        String currentStopTimeString = ""; 
	        String currentSlotString = "";

	        if(arrayListSize!=0)
	        {
	            //Insert defragList elements into the bitMap while deleting their old positions
	        	for(int i = 0;i<arrayListSize; i++)
	        	{
		       		slotInfo currentObject = null;
		        	currentObject = userPL.defragList.get(i);
		        	
		        	currentStartTimeString = getStartTime(currentObject); 
		            int currentStartTimeInt = Integer.parseInt(currentStartTimeString.trim());
		           
		            currentStopTimeString = getStopTime(currentObject); 
		            int currentStopTimeInt = Integer.parseInt(currentStopTimeString.trim());
		            
		            currentSlotString = getCarSlot(currentObject);
		            int currentSlotInt = Integer.parseInt(currentSlotString.trim());
		            
		            for(int time = currentStartTimeInt ; time<= currentStopTimeInt; time++)
		            {
		            	for(int slot = 0;slot<500;slot++)
		            	{
		            		if(slot == currentSlotInt)
		            			tempaBitMap[time][slot] = 1;
		            	}
		            	
		            }
	        	}
	        	
	        	
	        }
	        else
	        	System.out.println("ArrayList is not defined");
	}

	public ArrayList<slotInfo> generateNewDefragList() 
	{
		ArrayList<slotInfo> currentDefragList = new ArrayList<slotInfo>();
		
		int size = tempaSummaryVector.size();
		int startTime = 0;
		int stopTime = 0;
		int carRegnum = 0;
		int carSlot = 0;
		
		for(int i = 0; i<=size-4 ; i+=4)
		{
			carRegnum = tempaSummaryVector.get(i);
			startTime = tempaSummaryVector.get(i+1);
			stopTime = tempaSummaryVector.get(i+2);
			carSlot = tempaSummaryVector.get(i+3);
		

		int startSlot = (startTime *2)/100;
		int stopSlot = ((stopTime *2)/100)-1;
				
		String regnumString = Integer.toString(carRegnum);
		String parkingSlotString = Integer.toString(carSlot);
		String startIndexString = Integer.toString(startSlot);
		String stopIndexString = Integer.toString(stopSlot);
		
		slotInfo user = new slotInfo(regnumString,stopIndexString, startIndexString,parkingSlotString);
		currentDefragList.add(user);
		
		}
		return currentDefragList;
	}
	
	public void cancelReservation(ArrayList<slotInfo> defragList, int index)
	{
		//defragList.remove(0);
		defragList.remove(index);
	}

	public void generateFreeSpaceVector(int index)
	{
		int countZeros = 0;
		int startIndex = 0;
		int countOnes = 0;
		int insert = 0;
		int countChunks = 0;
		int[][] currentBitMap=new int [48][500];
		
		Vector<Integer> freeSpaceVector1 = new Vector<Integer>();
		
		
		if(index == 1)
		{
			currentBitMap = tempBitMap;//userPL.bitMap;//tempBitMap;
		}
		else if(index == 0)
		{
			currentBitMap = userPL.bitMap;
		}
		else
		{
			currentBitMap = tempaBitMap;
		}
		
		for(int slot = 0; slot<500; slot++)
		{
			countChunks = 0;
			countZeros = 0;
			for(int time = 0; time<48; time++)
			{
				if(currentBitMap[time][slot] == 0)
				{
					if(countOnes > 0)
					{
						countOnes = 0;
					}
					if(countZeros == 0)
						startIndex = time;
					countZeros++;
					
					
					continue;
				}
				else
				{
					if(countOnes == 0)
					{
						if(countZeros!=0)
						{
							freeSpaceVector1.add(slot);
							freeSpaceVector1.add(startIndex);
							freeSpaceVector1.add(countZeros);
							countChunks++;
							insert = 1;
						}
					}
					countZeros = 0;
					countOnes++;
					continue;
				}
			}
			if(insert!= 0)
			{
				if(countZeros!=0)
				{
					freeSpaceVector1.add(slot);
					freeSpaceVector1.add(startIndex);
					freeSpaceVector1.add(countZeros);
					countChunks++;
				}
			}				
					
		}
		
		int size1 = freeSpaceVector1.size();
		
		for(int k = 0; k<size1; k++)
			freeSpaceVector1.add(0);
		
		freeSpaceVector = freeSpaceVector1;
	}
		 
	public void scanAndAllotFreeSpaceVector(int currentStartTimeInt, int currentStopTimeInt, int currentcarRegnumInt, int currentSlotInt)
	{
        int size = freeSpaceVector.size();
        int nextStart = 0;
        int nextSlot = 0;
        for(int i = 0;i<= size-3; i+=3)
		{
			int tempSlot = freeSpaceVector.get(i);
			int tempStart = freeSpaceVector.get(i+1);
			int tempSize = freeSpaceVector.get(i+2);
			System.out.println("LOOKING AT TEMPSLOT="+tempSlot+" for object "+currentcarRegnumInt+" with startTime="+tempStart+ "and end time="+(tempStart+tempSize-1));
			System.out.println("The Free space vector is "+freeSpaceVector);
			if(i<=size-6)  //RED FLAG
			{
				nextStart = freeSpaceVector.get(i+4);
				nextSlot = freeSpaceVector.get(i+3);
			}
			int slotSize = currentStopTimeInt - currentStartTimeInt + 1;

			if(nextSlot == tempSlot)
			{		
				if((tempSlot < currentSlotInt))
				{
					if(((currentStartTimeInt >= tempStart) && (currentStartTimeInt < nextStart)))
					{
						int tempEnd = tempSize + tempStart;
						if(currentStopTimeInt<tempEnd)
						{
							insertBitMap2(currentStartTimeInt, currentStopTimeInt, currentSlotInt, tempSlot);
							generateFreeSpaceVector(2);
							int start = convertToTime(currentStartTimeInt,0);
							int stop = convertToTime(currentStopTimeInt,1);
							tempaSummaryVector.add(currentcarRegnumInt);
							tempaSummaryVector.add(start);
							tempaSummaryVector.add(stop);
							tempaSummaryVector.add(tempSlot);
							System.out.println("StartTime="+currentStartTimeInt);
							System.out.println("StopTime="+currentStopTimeInt);
							System.out.println("Slot="+currentSlotInt);
							System.out.println("####TempStartTime="+tempStart);
							System.out.println("####TempSize="+tempSize);
							System.out.println("####TempSlot="+tempSlot);
							System.out.println("FSV = "+freeSpaceVector);
							accessDatabase(tempSlot,currentcarRegnumInt);
							break;
						}
						else
						{
							System.out.println("Size not matching for "+i);
							continue;
							
						}
					}
					else
					{
						System.out.println("Looks like i reached here");
						continue;
					}
				}
				else 
				{
					System.out.println("Least possible slot");
					int start = convertToTime(currentStartTimeInt,0);
					int stop = convertToTime(currentStopTimeInt,1);
					tempaSummaryVector.add(currentcarRegnumInt);
					tempaSummaryVector.add(start);
					tempaSummaryVector.add(stop);
					tempaSummaryVector.add(tempSlot);
					accessDatabase(tempSlot,currentcarRegnumInt);
					break;
				}
			}
			else
			{	
				int tempEnd = tempSize + tempStart-1;
				int slotEnd = currentStopTimeInt;
				if((currentStartTimeInt>=tempStart) && (tempSize>slotSize))//&& (tempEnd >= slotEnd))
				{
					if (currentcarRegnumInt == 10086)
					{
						System.out.println("slotEnd == "+slotEnd);
						System.out.println("tempEnd == "+tempEnd);
					}
					if(tempSlot<currentSlotInt)
					{
						insertBitMap2(currentStartTimeInt, currentStopTimeInt, currentSlotInt, tempSlot);
						generateFreeSpaceVector(2);
						int start = convertToTime(currentStartTimeInt,0);
						int stop = convertToTime(currentStopTimeInt,1);
						tempaSummaryVector.add(currentcarRegnumInt);
						tempaSummaryVector.add(start);
						tempaSummaryVector.add(stop);
						tempaSummaryVector.add(tempSlot);
						System.out.println("@@@@StartTime="+currentStartTimeInt);
						System.out.println("@@@@StopTime="+currentStopTimeInt);
						System.out.println("@@@@Slot="+currentSlotInt);
						System.out.println("@@@@TempStartTime="+tempStart);
						System.out.println("@@@@TempSize="+tempSize);
						System.out.println("@@@@TempSlot="+tempSlot);
						System.out.println("FSV = "+freeSpaceVector);
						accessDatabase(tempSlot,currentcarRegnumInt);
						
						break;
					}
					else 
					{
						//System.out.println("Least possible slot in part 2");
						int start = convertToTime(currentStartTimeInt,0);
						int stop = convertToTime(currentStopTimeInt,1);
						tempaSummaryVector.add(currentcarRegnumInt);
						tempaSummaryVector.add(start);
						tempaSummaryVector.add(stop);
						tempaSummaryVector.add(tempSlot);
						break;
					}
				}
				else
				{
					//System.out.println("Reached here");
					continue;
				}
				
			}
				
		}
	}

	public void reArrangeFreeSpaceVector(int currentStartTimeInt, int currentStopTimeInt, int tempSlot) 
	{
		int getOut = 0;
		int size1 = freeSpaceVector.size();
	
		for (int j = 0; j< size1-3; j+=3)
		{
			int currentRunningSlot = freeSpaceVector.get(j);
	
			if(currentRunningSlot == tempSlot)
			{
				
				int currentRunningStart = freeSpaceVector.get(j+1);
				if(j <= size1-6)
				{
					int currentNextStart = freeSpaceVector.get(j+4);
	
					if((currentStartTimeInt>currentRunningStart)&&(currentStartTimeInt<currentNextStart))
					{
						int newStart = currentRunningStart;
						int size2 = freeSpaceVector.get(j+2);
						int size3 = freeSpaceVector.get(j+5); 
						int size4 = currentStopTimeInt-currentStartTimeInt + 1;
						int newSize = size2 + size3 + size4;
						freeSpaceVector.remove(j);
						freeSpaceVector.remove(j);
						freeSpaceVector.remove(j);
						freeSpaceVector.remove(j);
						freeSpaceVector.remove(j);
						freeSpaceVector.remove(j);
	
						freeSpaceVector.add(j, tempSlot);
						freeSpaceVector.add(j+1, newStart);
						freeSpaceVector.add(j+2, newSize);
						System.out.println("****************DELETED****************");
						getOut = 1;
						break;
					}
					
					else if((currentStartTimeInt<currentRunningStart))
					{
						int newStart =currentStartTimeInt;
						int size2 = currentStopTimeInt - currentStartTimeInt;
						int size3 = freeSpaceVector.get(j+2);
						int newSize = size2 + size3;
						freeSpaceVector.remove(j);
						freeSpaceVector.add(j, tempSlot);
						freeSpaceVector.add(j+1, newStart);
						freeSpaceVector.add(j+2, newSize);
						break;
						
					}
					
					else 
					{
						continue;
					}
				
				}
				
			}
			else 
			{
				continue;
			}
		
		}

	}
	
	public void accessDatabase(int tempSlot, int currentcarRegnumInt)
	{
		
		Connection conn = null;

        try
        {									

            String userName = "root";
            String password = "";
            String url = "jdbc:mysql://localhost/parkalot_system";
            Class.forName ("com.mysql.jdbc.Driver").newInstance ();
            conn = DriverManager.getConnection (url, userName, password);
        }
        catch (Exception e)
        {
            System.err.println ("Cannot connect to database server");
        }
        finally
        {
            if (conn != null)
            { 
               Statement stmt = null;
               try
               {
            	   stmt = (Statement) conn.createStatement();
            	   stmt.executeUpdate("UPDATE fsbm_data set new_slot ="+tempSlot+" WHERE car_regnum="+currentcarRegnumInt);

               }
               catch (SQLException e1)
               {
					e1.printStackTrace();
               }
            }
        }
	}
   
	public int countZeros(int highestSlot)
	{
		int zeros = 0;
		
		for(int slot = 0; slot<=highestSlot; slot++ )
		{
			for(int time = 0; time<48; time++)
			{
				if(tempaBitMap[time][slot] == 0)
					zeros = zeros + 1;
				
			}
		}
		return zeros;
	}

	public void accessDatabase1(int numberOfZeros, int index)
{
		
		Connection conn = null;

        try
        {									

            String userName = "root";
            String password = "";
            String url = "jdbc:mysql://localhost/parkalot_system";
            Class.forName ("com.mysql.jdbc.Driver").newInstance ();
            conn = DriverManager.getConnection (url, userName, password);
        }
        catch (Exception e)
        {
            System.err.println ("Cannot connect to database server");
        }
        finally
        {
            if (conn != null)
            { 
               Statement stmt = null;
               try
               {
            	   stmt = (Statement) conn.createStatement();
            	   if(index == 0)
            		   stmt.executeUpdate("UPDATE fsbm_data set beforeZeros ="+numberOfZeros+" WHERE car_regnum=10000");
            	   else if (index == 1)
            		   stmt.executeUpdate("UPDATE fsbm_data set afterZeros ="+numberOfZeros+" WHERE car_regnum=10000");
            	   else if (index == 2)
            		   stmt.executeUpdate("UPDATE fsbm_data set beforePacked ="+numberOfZeros+" WHERE car_regnum=10000");
            	   else if (index == 3)
            		   stmt.executeUpdate("UPDATE fsbm_data set afterPacked ="+numberOfZeros+" WHERE car_regnum=10000");
            	   else if (index == 10)
            		   stmt.executeUpdate("UPDATE fsbm_data set highSlot1 ="+(numberOfZeros+1)+" WHERE car_regnum=10000");
            	   else if (index == 11)
            		   stmt.executeUpdate("UPDATE fsbm_data set highSlot2 ="+(numberOfZeros+1)+" WHERE car_regnum=10000");

               }
               catch (SQLException e1)
               {
					e1.printStackTrace();
               }
            }
        }
	}

	public int getHighestSlot(int index)
	{
		int highestSlot = 0;
		int [][]currentBitMap = new int[48][500];
		
		if(index == 0)
			currentBitMap = userPL.bitMap;
		else
			currentBitMap = tempaBitMap;
		for(int slot = 0; slot<500; slot++ )
		{
			for(int time = 0; time<48; time++)
			{
				if(currentBitMap[time][slot] == 1)
					highestSlot = slot;
				
			}
			
		}
		return highestSlot;
	}

	public int countZeros1(int highestSlot)
	{
		int zeros = 0;
		int slot = 0;
		int lastOne = 0;
		
		for(slot = 0; slot<highestSlot; slot++ )
		{
			for(int time = 0; time<48; time++)
			{
				if(tempaBitMap[time][slot] == 0)
					zeros = zeros + 1;
				
			} 
		}
		
		for(int time = 0; time<48 ; time++)
			if(tempaBitMap[time][slot] == 1)
				lastOne = time;
		
		for(int time = 0; time<=lastOne ; time++)
			if(tempaBitMap[time][slot] == 0)
				zeros = zeros + 1;
		
		return zeros;
	}

	public int generate_random(int start, int range)
	{
	 	Random generator = new Random();
	    int r = generator.nextInt(range) + start;
	    return (r);
	}

	public void calculateLinkSize(int[][] tempBitMap2, int index) 
	{
		int count = 0;
		int countOne = 0;
		int insert = 0;
		  
		FileWriter fstream = null;
		try 
		
		{
			if(index == 0)
				fstream = new FileWriter("C:/Users/The Rao/Desktop/predefrag.txt");
			else
				fstream = new FileWriter("C:/Users/The Rao/Desktop/postdefrag.txt");
			
		}
		
		catch (IOException e1) 
		{
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		BufferedWriter out = new BufferedWriter(fstream);
		for(int slot = 0; slot<500; slot++)
		{
			for(int time = 0;time <48; time++)
			{
				if(tempBitMap2[time][slot] == 0)
				{
					count++;
					countOne = 0;
					if(time == 47)
					{
						System.out.println(slot+ " "+count);
									  // Create file 
							
						  try 
						  {
							out.write(slot+ " "+count);
							 out.newLine();
							  //Close the output stream

						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						 					  
						count = 0;
					}
				}
				else 
				{
					countOne++;
					if(count != 48 && countOne == 1)
					{
						System.out.println("At Slot = "+slot+ " Link Length = "+count);
						try{
							  // Create file 
							  //FileWriter fstream = new FileWriter("gandalf.txt");
							  //BufferedWriter out = new BufferedWriter(fstream);
							  out.write(slot+ " "+count);
							  out.newLine();
							  //Close the output stream
							  
							  }catch (Exception e){//Catch exception if any
							  System.err.println("Error: " + e.getMessage());
							  }
						count = 0;
						insert = 1;
					}
					
					continue;
				}
					
			}
			//if(insert == 0 && count != 0 )
			//{
				//System.out.println("At Slot = "+slot+ " Link Length = "+count);
				//count = 0;
		//	}

		}
		try {
			out.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	

	}


}
