import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.Random;
import java.util.Vector;

public class Track_2 implements Runnable 
{
	Thread t;
	int reserved_space=0;
	String car_regnum="";
	int[] choice;
	int random_index=0;
	Vector<Integer> actual_path=new Vector<Integer>();
	long tsTime1=0;
	long tsTime2=0;
	boolean changePath = false;
	Vector<Integer> modified_path;
	int last_node = 0;
	int max_node = 0;
	HashMap<String,Track_2> parent;
	int wrongPrediction = 0;
	int wrongPath = 0;


	Track_2(HashMap<String, Track_2> parent, String pass_regnum, String final_slot)
	{
		t = new Thread(this,pass_regnum);
		this.parent = parent; 
		car_regnum=pass_regnum;
		reserved_space= Integer.parseInt(final_slot.trim());
	
	//Setting up database connection
		
		Connection conn = null;

		   try
		   {
		       String userName = "root";
		       String password = "";
		       String url = "jdbc:mysql://localhost/parkalot_system";
		       Class.forName ("com.mysql.jdbc.Driver").newInstance ();
		       conn = DriverManager.getConnection (url, userName, password);
		   }
		   catch (Exception e)
		   {
		       System.err.println ("Cannot connect to database server in constructor");
		   }
		   finally
		   {
		       if (conn != null)
		       {
		    	   Statement stmt = null;
		        	 
		           try
		           {	
		        	   //Block user from being used again and also make an entry in database about user's presence in parking lot
		        	   
		        	   	stmt = conn.createStatement();
						stmt. executeUpdate("UPDATE temp_slot set temp_used=1,temp_block=1 where temp_regnum="+car_regnum);
						
						// To check if reserved slot has already gotten alloted to someone(say someone parked wrongly at the reserved spot)
						// If so, then generate a random slot and allot it to the user
						
						ResultSet rs = stmt.executeQuery("SELECT slot_alloted FROM `use_slot_temp` WHERE slot_number="+final_slot);
						if(rs.next())
						{
							String slot_status=rs.getString(1);
						    int slot_compare = Integer.parseInt(slot_status.trim());
						    
							if(slot_compare==0)
							{
								stmt. executeUpdate("UPDATE use_slot_temp set slot_alloted=1 where slot_number="+final_slot);
								stmt. executeUpdate("UPDATE use_slot_temp set slot_regnum_alloted="+car_regnum+" where slot_number="+final_slot);
								System.out.println("\n\n\nRegnum "+car_regnum+" has entered the parking lot parking for slot="+final_slot);
								//System.out.println("Slot was available");
								
							}
							
						// Random slot generation as described above
							
							else 
							{
								int temp_slot=generate_random(100,500);
								final_slot = Integer.toString(temp_slot);
//INCORPORATE SITUATION WHERE EVEN RANDOMLY CHOSEN SLOT IS PREVIOUSLY ALLOTED BY RECURRENCE CALL OF RANDOM SLOT GENERATION
								stmt. executeUpdate("UPDATE use_slot_temp set slot_alloted=1 where slot_number="+final_slot);
								stmt. executeUpdate("UPDATE use_slot_temp set slot_regnum_alloted="+car_regnum+" where slot_number="+final_slot);
								System.out.println("\n\n\nRegnum "+car_regnum+" has entered the parking lot parking for slot="+final_slot);
								//System.out.println("Had to change slot since it was alloted");
								reserved_space=Integer.parseInt(final_slot.trim());
							}
							
						}
					} 
		           catch (SQLException e1)
		           {
						e1.printStackTrace();
		           }
		    	  
		           try
		           {
		               conn.close ();
		           }
		           catch (Exception e)
		           { 
		           }
		       }
		   	}	
		
			t.start();

	}

	public void simulate_actual_car_path(int random_index)
	{
		Vector<Integer> actual_path=new Vector<Integer>();
		int i=0;
		int random_slot=0;
		int actual_floor=0;
		int actual_slot=0;
		int actual_space=0;
		//int tempa=Integer.parseInt(car_regnum);
		int slotNum = 0;
		boolean didBreak = false;
		
		if(random_index==1)
		{
		
			//generating floor sensors vector
				
			actual_floor=generate_random(1,5);
			

		//	if(tempa==10000)
		//	{
			//	actual_floor = 1;

		//	}
		//	if(tempa==10001)
		//	{
		//		actual_floor = 1;

		//	}
			for(i=1;i<actual_floor;i++)
			{
				actual_path.addElement(new Integer(1000*i));
			}
			
			int row = 0;
			//adding row indicator vector
			
			if(actual_floor == 1)
			{
				row=generate_random(6,4);
			/*	if(tempa==10000)
				{
					row = 6;

				}
				if(tempa==10001)
				{
					row =6;

				}*/
				actual_path.addElement(new Integer(1000*row));
			}
			
			if(actual_floor == 2)
			{
				row=generate_random(10,4);
				actual_path.addElement(new Integer(1000*row));
			}
			
			if(actual_floor == 3)
			{
				row=generate_random(14,4);
				actual_path.addElement(new Integer(1000*row));
			}
			
			if(actual_floor == 4)
			{
				row=generate_random(18,4);
				actual_path.addElement(new Integer(1000*row));
			}
			
			if(actual_floor == 5)
			{
				row=generate_random(22,4);
				actual_path.addElement(new Integer(1000*row));
			}
			//if you need another sensor addition for speed calculation add it after this comment
			actual_path.addElement(new Integer((1000*row)+1));
			
			if(row == 6 || row == 10 || row == 14 || row == 18 || row == 22)
			{
				random_slot=generate_random(0,17);
		
		/*		if(tempa==10000)
				{
					random_slot = 1;

				}
				if(tempa==10001)
				{
					random_slot = 1;

				}*/
				actual_path.addElement(new Integer((actual_floor*100)+random_slot));
	
			}
			
			if(row == 7 || row == 11 || row == 15 || row == 19 || row == 23)
			{
				random_slot=generate_random(17,34);
				actual_path.addElement(new Integer((actual_floor*100)+random_slot));
			}
			
			if(row == 8 || row == 12 || row == 16 || row == 20 || row == 24)			
			{
				random_slot=generate_random(51,34);
				actual_path.addElement(new Integer((actual_floor*100)+random_slot));
			}
			
			if(row == 9 || row == 13 || row == 17 || row == 21 || row == 25)			
			{
				random_slot=generate_random(85,15);
				actual_path.addElement(new Integer((actual_floor*100)+random_slot));
				
			}
			System.out.println("Actual floor="+actual_floor);
			System.out.println("Actual slot="+random_slot);
			actual_space=(actual_floor*100)+random_slot;
		}
		
		else if (random_index==0)
		{
			actual_floor=reserved_space/100;
			actual_slot=reserved_space-(actual_floor*100);
			
			
			for(i=1;i<actual_floor;i++)
			{
				actual_path.addElement(new Integer(1000*i));
			}
			
			
			if((actual_slot>=0)&&actual_slot<=16)
			{
				if(actual_floor == 1)
				{
					actual_path.addElement(new Integer(6000));
					actual_path.addElement(new Integer(6001));
				}
				
				if(actual_floor == 2)
				{
					actual_path.addElement(new Integer(10000));
					actual_path.addElement(new Integer(10001));
				}
				
				if(actual_floor == 3)
				{
					actual_path.addElement(new Integer(14000));
					actual_path.addElement(new Integer(14001));
				}
				
				if(actual_floor == 4)
				{
					actual_path.addElement(new Integer(18000));
					actual_path.addElement(new Integer(18001));
				}
				
				if(actual_floor == 5)
				{
					actual_path.addElement(new Integer(22000));
					actual_path.addElement(new Integer(22001));
				}
				
				actual_path.addElement(new Integer((actual_floor*100)+actual_slot));
			}
			
			else if((actual_slot>=17)&&actual_slot<=50)
			{
				if(actual_floor == 1)
				{
					actual_path.addElement(new Integer(7000));
					actual_path.addElement(new Integer(7001));
				}
				
				if(actual_floor == 2)
				{
					actual_path.addElement(new Integer(11000));
					actual_path.addElement(new Integer(11001));
				}
				
				if(actual_floor == 3)
				{
					actual_path.addElement(new Integer(15000));
					actual_path.addElement(new Integer(15001));
				}
				
				if(actual_floor == 4)
				{
					actual_path.addElement(new Integer(19000));
					actual_path.addElement(new Integer(19001));
				}
				
				if(actual_floor == 5)
				{
					actual_path.addElement(new Integer(23000));
					actual_path.addElement(new Integer(23001));
				}
				
				actual_path.addElement(new Integer((actual_floor*100)+actual_slot));
			}
			
			else if((actual_slot>=51)&&actual_slot<=84)
			{
				if(actual_floor == 1)
				{
					actual_path.addElement(new Integer(8000));
					actual_path.addElement(new Integer(8001));
				}
				
				if(actual_floor == 2)
				{
					actual_path.addElement(new Integer(12000));
					actual_path.addElement(new Integer(12001));
				}
				
				if(actual_floor == 3)
				{
					actual_path.addElement(new Integer(16000));
					actual_path.addElement(new Integer(16001));
				}
				
				if(actual_floor == 4)
				{
					actual_path.addElement(new Integer(20000));
					actual_path.addElement(new Integer(20001));
				}
				
				if(actual_floor == 5)
				{
					actual_path.addElement(new Integer(24000));
					actual_path.addElement(new Integer(24001));
				}
				
				actual_path.addElement(new Integer((actual_floor*100)+actual_slot));
			}
			
			else if((actual_slot>=85)&&actual_slot<=99)
			{
				if(actual_floor == 1)
				{
					actual_path.addElement(new Integer(9000));
					actual_path.addElement(new Integer(9001));
				}
				
				if(actual_floor == 2)
				{
					actual_path.addElement(new Integer(13000));
					actual_path.addElement(new Integer(13001));
				}
				
				if(actual_floor == 3)
				{
					actual_path.addElement(new Integer(17000));
					actual_path.addElement(new Integer(17001));
				}
				
				if(actual_floor == 4)
				{
					actual_path.addElement(new Integer(21000));
					actual_path.addElement(new Integer(21001));
				}
				
				if(actual_floor == 5)
				{
					actual_path.addElement(new Integer(25000));
					actual_path.addElement(new Integer(25001));
				}
				
				actual_path.addElement(new Integer((actual_floor*100)+actual_slot));
			}
			actual_space=reserved_space;
		}
							
		int size=(Integer)actual_path.size();
		int sleep_time=0;
		generate_random(400,3600);
		
		int current_sensor_id = 0;
		for(i=0;i<size-1;i++)
		{
			if(changePath == false)
			{
				current_sensor_id = (Integer)(actual_path.get(i));
				
				if(i>0)
				{
					int previous_sensor_id = (Integer)(actual_path.get(i-1));
					last_node = previous_sensor_id;
				}
				else
					last_node = current_sensor_id;
				
				int num = generate_random(1,50);

				if((current_sensor_id%1000==0) && (current_sensor_id<=4000))
				{
					sleep_time = 10000;  //2 seconds to go from floor sensor to x000
				}

				if((current_sensor_id%1000==0) && (current_sensor_id>4000))
				{
					sleep_time = 8000;  //2 seconds to go from floor sensor to x000
				}
				
				else if ((current_sensor_id%1000 == 1) && (current_sensor_id>4000))
				{
					sleep_time = 2000;  //2 seconds to go from floor sensor to x000

				}
				
				if (current_sensor_id<1000)
				{
					int curFloor = current_sensor_id/100;
					int curSlot = current_sensor_id-(curFloor*100);
					int curRow = 0;
					
					if (curSlot<17)
						curRow = 0;
					if (curSlot<34&&curSlot>16)
						curRow = 1;
					if (curSlot<51&&curSlot>33)
						curRow = 2;
					if (curSlot<68&&curSlot>50)
						curRow = 3;
					if (curSlot<85&&curSlot>67)
						curRow = 4;
					if (curSlot<100&&curSlot>84)
						curRow = 5;

					
					slotNum = 17 - (curSlot - (curRow*17));                                                                                                                                                                     
					System.out.println("slotNum="+slotNum);
					System.out.println("curSlot="+curSlot);
					System.out.println("curRow="+curRow);
					sleep_time = 550*slotNum;
				}
				//System.out.println("Sleep time = "+sleep_time+" for car regnum"+car_regnum);

				try
				{
					if (current_sensor_id<1000)
					{
						int ir = 0;
						for(ir = 0; ir<slotNum; ir++ )
						{
							if(changePath == false)
							{
								Thread.sleep(550);
							}
							else
							{
								System.out.println("Inner section break was true");
								System.out.println("ir="+ir);
								break;
							}
						}
					}
					else 
						Thread .sleep(sleep_time);
					
					if(didBreak == true)
					{
						System.out.println("DidBreak was true");
						break;
					}
					if (num != 2)
					{
						//System.out.println("current slot for "+car_regnum+" is "+current_sensor_id);
						generate_actual_path(current_sensor_id,0,actual_space,size);
					}
					else
						System.out.println("Failure node is "+current_sensor_id);
				
				} 
				catch (InterruptedException e) 
				{
					e.printStackTrace();
				}
	
				
			}
			else 
			{
				System.out.println("Main section breaks");
				break;
			}
		}
		
		if(changePath == true)
		{
	    	System.out.println("@@@@@@@@@@There has been a change in FINAL DESTINATION@@@@@@@@@");
	    	
	    	modify_current_path(last_node);
	    }
		else
		{
			int num = generate_random(1,50);
			int finalNode = actual_path.get(size-1);
			if (num != 2)
			{
				generate_actual_path(finalNode,1,actual_space,size);
			}
			else
			{
				System.out.println("Last Node failed");
				generate_actual_path(0,1,actual_space,size);
			}
		}
	}
	
	public void generate_actual_path(int current_sensor_id,int is_final_slot,int actual_space, int size)
	{
		 if(is_final_slot==0)
		{
			 //To account for processing time
			 try 
			 {
				Thread.sleep(186);
			 } 
			 catch (InterruptedException e) 
			 {
				e.printStackTrace();
			 }
			 
			actual_path.addElement(new Integer(current_sensor_id));
			int mod1=current_sensor_id % 1000;
			if((current_sensor_id>5000))
			{
				if (mod1==0)
				{
					java.util.Date today = new java.util.Date();
				    java.sql.Timestamp ts1 = new java.sql.Timestamp(today.getTime());
				    tsTime1 = ts1.getTime();
				 
				}
				
				if (mod1!=0)
				{
					java.util.Date today = new java.util.Date();
				    java.sql.Timestamp ts2 = new java.sql.Timestamp(today.getTime());
				    tsTime2 = ts2.getTime();
				   
				}
				
			}
		   
		    double diff_time=tsTime2-tsTime1;
		  
		    if(diff_time>0)
		    {
				double car_speed=calculate_speed(diff_time);
		    }
		System.out.println(actual_path);
			
		}		
		else if(is_final_slot==1)
		{
			if(current_sensor_id == 0)
			{
				wrongPrediction = 1;
			}
			actual_path.add(current_sensor_id);
			int finalSize = actual_path.size();
			
			if (finalSize<=(size*0.9)) 
			{
					wrongPrediction = 1;
			}
			System.out.println(actual_path);
			System.out.println("Final Size="+finalSize);
			System.out.println("Real Size="+size);
			
			Connection conn = null;

			   try
			   {
			       String userName = "root";
			       String password = "";
			       String url = "jdbc:mysql://localhost/parkalot_system";
			       Class.forName ("com.mysql.jdbc.Driver").newInstance ();
			       conn = DriverManager.getConnection (url, userName, password);
			   }
			   catch (Exception e)
			   {
			       System.err.println ("Cannot connect to database server in generate path");
			   }
			   finally
			   {
			       if (conn != null)
			       {
			    	   Statement stmt1 = null;
			        	 
			           try
			           {	
			        	   	stmt1 = conn.createStatement();
							if(actual_space!=reserved_space)
								wrongPath = 1;
			        	   	stmt1. executeUpdate("UPDATE use_slot_temp set slot_overbook="+finalSize+"+ slot_overbook where slot_number="+100);

							if(wrongPath == 1)
							{
								System.out.println("User "+car_regnum+" has parked in the wrong spot!");
								stmt1. executeUpdate("UPDATE use_slot_temp set slot_alloted=1 where slot_number="+actual_space);
								stmt1. executeUpdate("UPDATE use_slot_temp set slot_alloted=0 where slot_number="+reserved_space);
								stmt1. executeUpdate("UPDATE use_slot_temp set slot_regnum_alloted=0 where slot_number="+reserved_space);
								stmt1. executeUpdate("UPDATE use_slot_temp set slot_status='Occupied' where slot_number="+actual_space);
								stmt1. executeUpdate("UPDATE use_slot_temp set slot_regnum="+car_regnum+" where slot_number="+actual_space);
								stmt1. executeUpdate("UPDATE temp_slot set slot_sensor="+wrongPrediction+" where temp_regnum="+car_regnum);
								stmt1. executeUpdate("UPDATE use_slot_temp SET slot_wrong = slot_wrong+1 Where slot_number = 100");
								ResultSet get_1 = stmt1.executeQuery("SELECT slot_regnum_alloted FROM `use_slot_temp` WHERE slot_number="+actual_space);
								if(get_1.next())
								{
									String alloted_regnum=get_1.getString(1);
									if(alloted_regnum=="")
									{
										System.out.println("ROGUEEEEEEEEEEEEEEEEEEEEEEEe");

									}
								    int k = Integer.parseInt(alloted_regnum.trim());
								    if(k>0)
								    {
										ResultSet get_2 = stmt1.executeQuery("SELECT slot_regnum FROM `use_slot_temp` WHERE slot_number="+actual_space);
										if(get_2.next())
										{
											String parked_regnum=get_2.getString(1);
										    int m = Integer.parseInt(parked_regnum.trim());
										    if(m!=k)
										    {
										    	//No. of wrong bookings can be counted here
										    	if(parent.containsKey(alloted_regnum))
										    	{
										    		System.out.println("It does contain");
											    	Track_2 niceGuy = parent.get(alloted_regnum);
											    	int new_number=100;
											    	System.out.println("Calling the niceGuy from "+car_regnum+" for slot "+m);
											    	niceGuy.informNiceGuy(new_number,niceGuy);
										    	}
										    	else
										    	{
										    		System.out.println("It does not contain ");
										    	}										    		
										    }
										    else
										    {
										    	
										    }
										    
										}


								    }
								    else
								    {
								    	
								    }

								}
							}
							else
							{

								System.out.println("User "+car_regnum+" has parked in the correct spot!");
								stmt1. executeUpdate("UPDATE use_slot_temp set slot_status='Occupied' where slot_number="+reserved_space);
								stmt1. executeUpdate("UPDATE use_slot_temp set slot_regnum="+car_regnum+" where slot_number="+reserved_space);
								stmt1. executeUpdate("UPDATE temp_slot set slot_sensor="+wrongPrediction+" where temp_regnum="+car_regnum);
								stmt1. executeUpdate("UPDATE use_slot_temp SET slot_right = slot_right+1 Where slot_number = 100");

							}

			           } 
			           catch (SQLException e1)
			           {
							e1.printStackTrace();
			           }
			       }

			   }
		}
		
	}
	
	public double calculate_speed(double diff)
	{
		double diff_time=(diff)/(1000*60*60);
		double speed= (0.00227272727/diff_time);
		return(speed);
	
	}

	public void run() 
	{
		int random_index=0;
		random_index=generate_random(0,2);
		//int tempa=Integer.parseInt(car_regnum);
		//if (tempa==10000)
		//	random_index=1;
		//if (tempa == 10001)
		//	random_index = 0;
		System.out.println("Random slot  passed as final destination is = "+random_index);
		simulate_actual_car_path(random_index);
		
	}
	
	public int generate_random(int start, int range)
	{
	 	Random generator = new Random();
	    int r = generator.nextInt(range) + start;
	    return (r);
	}
	
	public void informNiceGuy(int new_number, Track_2 niceGuy)
{
	System.out.println(this);
	System.out.println("#####################################That special case has been reached");
	//niceGuy.t.sleep(10000);
	//t.sleep(1000);
	changePath = true;
	//niceGuy.
	System.out.println("FInished SLepepingafaf@@@@@@@@@@@@@@@@@"+this.car_regnum);
	System.out.println("changePath for "+car_regnum+ "is "+changePath);
	//int tempa=Integer.parseInt(car_regnum);
	//if(tempa == 10001)
		//System.out.println("last node is "+last_node);
	
}

	public void modify_current_path(int last_node) 
	{		
		modified_path = new Vector<Integer>();
		System.out.println("IN MODIFY_CURRENT_PATH&&&&&&&&&&&&&&&&&&");
		
        int start=0;
        int range=0;
        int newNode = 0;
        int currentFloor = 0;
        int currentRow = 0;
        System.out.println("last node="+last_node+" for car regnum="+car_regnum);

        if(last_node == 1000)
        	currentFloor = 2;
        if(last_node == 2000)
        	currentFloor = 3;
        if(last_node == 3000)
        	currentFloor = 4;
        if(last_node == 4000)
        	currentFloor = 5;

        if((last_node >=6000) && (last_node<=9000))
        {
        	currentFloor = 1;
        	if(last_node == 6000 || last_node ==6001)
        		currentRow = 1;
        	if(last_node == 7000 || last_node ==7001)
        		currentRow = 2;
        	if(last_node == 8000 || last_node ==8001)
        		currentRow = 3;
        	if(last_node == 9000 || last_node ==9001)
        		currentRow = 4;
        }
        if((last_node >=10000) && (last_node<=13000))
        {
        	currentFloor = 2;
          	if(last_node == 10000 || last_node ==10001)
        		currentRow = 1;
        	if(last_node == 11000 || last_node ==11001)
        		currentRow = 2;
        	if(last_node == 12000 || last_node ==12001)
        		currentRow = 3;
        	if(last_node == 13000 || last_node ==13001)
        		currentRow = 4;
        }
        if((last_node >=14000) && (last_node<=17000))
        {
        	currentFloor = 3;
          	if(last_node == 14000 || last_node ==14001)
        		currentRow = 1;
        	if(last_node == 15000 || last_node ==15001)
        		currentRow = 2;
        	if(last_node == 16000 || last_node ==16001)
        		currentRow = 3;
        	if(last_node == 17000 || last_node ==17001)
        		currentRow = 4;
        }
        if((last_node >=18000) && (last_node<=21000))
        {
        	currentFloor = 4;
          	if(last_node == 18000 || last_node ==18001)
        		currentRow = 1;
        	if(last_node == 19000 || last_node ==19001)
        		currentRow = 2;
        	if(last_node == 20000 || last_node ==20001)
        		currentRow = 3;
        	if(last_node == 21000 || last_node ==21001)
        		currentRow = 4;
        }
        if((last_node >=22000) && (last_node<=25000))
        {
        	currentFloor = 5;
          	if(last_node == 22000 || last_node ==22001)
        		currentRow = 1;
        	if(last_node == 23000 || last_node ==23001)
        		currentRow = 2;
        	if(last_node == 24000 || last_node ==24001)
        		currentRow = 3;
        	if(last_node == 25000 || last_node ==25001)
        		currentRow = 4;
        }
         
        int newSlot = 0;
        if(currentRow == 1)
        {
        	start = currentFloor*100;
        	newSlot = generate_random(start,17);
        }
        
        if(currentRow == 2)
        {
        	start = currentFloor*100 + 17; 
        	newSlot = generate_random(start,34);
        }
        
        if(currentRow == 3)
        {
        	start = currentFloor*100 + 51; 
        	newSlot = generate_random(start,34);
        }
        
        if(currentRow == 4)
        {
        	start = currentFloor*100 + 85; 
        	newSlot = generate_random(start,17);
        }
        
        Connection conn = null;

		   try
		   {
		       String userName = "root";
		       String password = "";
		       String url = "jdbc:mysql://localhost/parkalot_system";
		       Class.forName ("com.mysql.jdbc.Driver").newInstance ();
		       conn = DriverManager.getConnection (url, userName, password);
		   }
		   catch (Exception e)
		   {
		       System.err.println ("Cannot connect to database server in random_slot()");
		   }
		   finally
		   {
		       if (conn != null)
		       {
		    	   Statement stmt = null;
		        	 
		           try
		           {	
		        	   	stmt = conn.createStatement();
		        	   	ResultSet rs = stmt.executeQuery("SELECT slot_alloted FROM `use_slot_temp` WHERE slot_number="+newSlot);
						
		        	   	//generate random slot. if slot is occupied, generate another random slot.
		        	   	
						if(rs.next())
						{
							String random_status_1=rs.getString(1);
						    int random_status = Integer.parseInt(random_status_1.trim());
							if (random_status==0)
							{
								stmt. executeUpdate("UPDATE use_slot_temp set slot_alloted=1 where slot_number="+newSlot);
								stmt. executeUpdate("UPDATE use_slot_temp set slot_regnum_alloted="+car_regnum+" where slot_number="+newSlot);
								
							}
							else 
							{
								start = currentFloor * 100;
								range = 500-start;
								newSlot = generate_random(start,range);
							}
						}
						
					} 
		           catch (SQLException e1)
		           {
						e1.printStackTrace();
		           }
		       }
		   }
		   
		   //creating modified path vector
			actual_path = new Vector<Integer>();
			
		//HACK
		//	newSlot = 599;
		   int r_floor = newSlot/100;
		   int r_slot = newSlot-(r_floor*100);
		   int r_row =0;
		   
		   if (r_slot>=0 && r_slot<=16)
			   r_row =1;
		   if (r_slot>=17 && r_slot<=50)
			   r_row =2;
		   if (r_slot>=51 && r_slot<=84)
			   r_row =3;
		   if (r_slot>=85 && r_slot<=99)
			   r_row =4;
		   
		   System.out.println("!!!!!!!!!!!!!!!!New slot is "+r_slot);
		   System.out.println("!!!!!!!!!!!!!!!!New floor is "+r_floor);
		   System.out.println("!!!!!!!!!!!!!!!!Current floor is "+currentFloor);
		   System.out.println("!!!!!!!!!!!!!!!!New row is "+r_row);
		   //detect if last node was a floor sensor or a row sensor and then decide the modified path
		   System.out.println("modified_path="+modified_path);
		   int remainder = 0;
		   remainder = last_node%1000;
		   
		   if((last_node<=4000) && (remainder == 0))
		   {
			   int lastFloor = last_node/1000;
			   
			   if(lastFloor<r_floor)
			   {
				   for(int i = lastFloor+1; i<r_floor; i++)
				   {
					   modified_path.add(i*1000);
				   }
				   newNode = getnewNode(r_row,r_floor);
				   modified_path.add(newNode);
				   modified_path.add(newNode+1);
				   modified_path.add(newSlot);

			   }
			   
			   if(lastFloor>r_floor)
			   {
				   for(int i = lastFloor; i> r_floor; i--)
				   {
					   modified_path.add((i*1000)+1);
				   }
				   newNode = getnewNode(r_row,r_floor);
				   modified_path.add(newNode);
				   modified_path.add(newNode+1);
				   modified_path.add(newSlot);

			   }
			   
			   if(lastFloor == r_floor)
			   {
				   newNode = getnewNode(r_row,r_floor);
				   modified_path.add(newNode);
				   modified_path.add(newNode+1);
				   modified_path.add(newSlot);
			   }
			   
		   }
		  
		   if((last_node>4000) && (remainder == 0))
		   {
			
			   if(currentFloor == r_floor)
			   {
				   if(currentRow==r_row)
				   {
					   modified_path.add(newSlot);

				   }
				   
				   else
				   {
					   modified_path.add(last_node+1);
					   modified_path.add(currentFloor*1000);
					   modified_path.add(((currentFloor+1)*1000)+1);
					   newNode = getnewNode(r_row,r_floor);
					   modified_path.add(newNode);
					   modified_path.add(newNode+1);
					   modified_path.add(newSlot);
   
				   }
			   	}
			   else if (currentFloor<r_floor)
			   {
			   	   modified_path.add(last_node+1);
			   	   for(int i=currentFloor;i<r_floor;i++)
			   	   {
			   		   modified_path.add((i*1000));
			   	   }
			   	   newNode = getnewNode(r_row,r_floor);
				   modified_path.add(newNode);
				   modified_path.add(newNode+1);
				   modified_path.add(newSlot);
			   	   

			   }
			   else if (currentFloor>r_floor)
			   {
				   modified_path.add(last_node+1);
			   	   for(int i=currentFloor;i>r_floor;i--)
			   	   {
			   		   modified_path.add((i*1000)+1);
			   	   }
			   	   newNode = getnewNode(r_row,r_floor);
				   modified_path.add(newNode);
				   modified_path.add(newNode+1);
				   modified_path.add(newSlot);

			   }
			   
		   }
		   
		   if((last_node>4000) && (remainder == 1))
		   {

			   if(currentFloor == r_floor)
			   {
				   if(currentRow==r_row)
				   {
					   modified_path.add(newSlot);

				   }
				   
				   else
				   {
					   modified_path.add(currentFloor*1000);
					   modified_path.add(((currentFloor+1)*1000)+1);
					   newNode = getnewNode(r_row,r_floor);
					   modified_path.add(newNode);
					   modified_path.add(newNode+1);
					   modified_path.add(newSlot);
   
				   }
			   }
			   else if (currentFloor<r_floor)
			   {
			   	   for(int i=currentFloor;i<r_floor;i++)
			   	   {
			   		   modified_path.add((i*1000));
			   	   }
			   	  
			   	   
			   	   
			   	   
			   	   newNode = getnewNode(r_row,r_floor);
			   	   modified_path.add(newNode);
				   modified_path.add(newNode+1);
				   modified_path.add(newSlot);
			   	   

			   }
			   else if (currentFloor>r_floor)
			   {
				   modified_path.add(last_node+1);
			   	   for(int i=currentFloor;i>r_floor;i--)
			   	   {
			   		   modified_path.add((i*1000)+1);
			   	   }
			   	   
				   newNode = getnewNode(r_row,r_floor);
				   modified_path.add(newNode);
				   modified_path.add(newNode+1);
				   modified_path.add(newSlot);

			   }
			   			   
		   }
		   
		   
		   //Insert the passing for loop here
		    int randNum = generate_random(4,28);
			int modified_size=(Integer)modified_path.size();
			double speed=(double) 36/randNum;
		    System.out.println("VALUE OF MODIFIED SPEED======================="+speed);
		    double time = 0;
		    
		    
		    if(speed<2.24)
		    	time = (double) ((2.24/speed));
		    else 
		    	time = (double) (Math.ceil(2.24/speed));
		    System.out.println("modifiied path="+modified_path);
		    System.out.println("modified_size="+modified_size);
			for(int i=0;i<modified_size;i++)
			{	
				System.out.println("*****************Passing Modified Sensor Path********************");
				int active_slot=(Integer)(modified_path.get(i));
				System.out.println("active_slot="+active_slot);
				int remainder1 = active_slot%1000; 
				if(remainder1 == 0 && active_slot<=4000 )
				{
					try
					{
						Thread.sleep(1000*randNum);
						int failureProbability = generate_random(1,50);
				        if(failureProbability!=2)
				        {
				        	generate_actual_path(active_slot,0,newSlot,modified_size);
				        	//construct_ap(car_regnum,active_slot,r_slot,r_floor,0);
				        }
	
					} 
					catch (InterruptedException e) 
					{
						e.printStackTrace();
					}
					System.out.println("A floor sensor with time "+randNum+" for "+car_regnum);
	
				}
				else
				{
				    
	
					System.out.println("Not a floor sensor with time "+time+" for "+car_regnum);
					try
					{
						Thread.sleep((long)time*1000);
						System.out.println("Sleep just completed");
						int failureProbability = generate_random(1,50);
				        if(failureProbability!=1)
				        {
				        	System.out.println("failure number is "+failureProbability);
				        	generate_actual_path(active_slot,0,newSlot,modified_size);
				        	//construct_ap(car_regnum,active_slot,r_slot,r_floor,0);
				        }
					} 
					catch (InterruptedException e) 
					{
						e.printStackTrace();
					}
				}
			}
			int actual_stop=(Integer)(modified_path.get(modified_size-1));
			generate_actual_path(actual_stop,1,newSlot,modified_size);
			//construct_ap(car_regnum,actual_stop,r_slot,r_floor,1);

	}
	
	public int getnewNode(int r_row, int r_floor)
{
	int newNode = 0;
	
	 if(r_row == 1)
 	   {
 		   if(r_floor == 1)
 		   {
 			   newNode = 6000;
 		   }
 		   
 		   if(r_floor == 2)
 		   {
 			   newNode = 10000;
 		   }
 		   
 		   if(r_floor == 3)
 		   {
 			   newNode = 14000;
 		   }
 		   
 		   if(r_floor == 4)
 		   {
 			   newNode = 18000;
 		   }
 		   
 		   if(r_floor == 5)
 		   {
 			   newNode = 22000;
 		   }
 	   }
	 	
	   if(r_row == 2)
	   {
		   if(r_floor == 1)
		   {
			   newNode = 7000;
		   }
		   
		   if(r_floor == 2)
		   {
			   newNode = 11000;
		   }
		   
		   if(r_floor == 3)
		   {
			   newNode = 15000;
		   }
		   
		   if(r_floor == 4)
		   {
			   newNode = 19000;
		   }
		   
		   if(r_floor == 5)
		   {
			   newNode = 23000;
		   }
	   }
	   
		   if(r_row == 3)
	 	   {
	 		   if(r_floor == 1)
	 		   {
	 			   newNode = 8000;
	 		   }
	 		   
	 		   if(r_floor == 2)
	 		   {
	 			   newNode = 12000;
	 		   }
	 		   
	 		   if(r_floor == 3)
	 		   {
	 			   newNode = 16000;
	 		   }
	 		   
	 		   if(r_floor == 4)
	 		   {
	 			   newNode = 20000;
	 		   }
	 		   
	 		   if(r_floor == 5)
	 		   {
	 			   newNode = 24000;
	 		   }
	 	   }
		   
			 if(r_row == 4)
		 	   {
		 		   if(r_floor == 1)
		 		   {
		 			   newNode = 9000;
		 		   }
		 		   
		 		   if(r_floor == 2)
		 		   {
		 			   newNode = 13000;
		 		   }
		 		   
		 		   if(r_floor == 3)
		 		   {
		 			   newNode = 17000;
		 		   }
		 		   
		 		   if(r_floor == 4)
		 		   {
		 			   newNode = 21000;
		 		   }
		 		   
		 		   if(r_floor == 5)
		 		   {
		 			   newNode = 25000;
		 		   }
		 	   }
			 
			 return (newNode);
}
		
}
