import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Collections;
import java.util.HashMap;
import java.util.Random;
import java.util.Vector;

public class matrix_new_arrival implements Runnable 
{
	Vector<Integer> actual_path;
	Vector<Integer> parking_lot_path;
	Vector<Integer> defined_path;
	Vector<Integer> modified_path;
	int count_size=0;
	Vector<Integer> sensor_path;
	int parking_lot_size=0;
	int actual_size=0;
	int final_size_2=0;
	boolean changePath=false;
	int last_node=0;
	int max_node=0;
	int wrongPath = 0;
	int currentIndex=0;
	int currentIndexSensor = 0;
	int wrongPrediction = 0;
	int sensor_path_size = 0;

	Thread t;
	String arr_regnum="";
	String arr_slot="";
	String wait_time="";
	int total_slot=0;
	int use_floor=0;
	int use_slot=0;
	int final_random_floor=0;
	int[] choice;
	int random_index=0;
	HashMap<String,matrix_new_arrival> parent;

	//Creating constructor
	
	matrix_new_arrival(HashMap<String,matrix_new_arrival> parent, String arr_threadid,String slot)
	{	
		t = new Thread(this, arr_threadid);
		this.parent = parent; 
		arr_slot=slot;
		arr_regnum=arr_threadid;
		total_slot = Integer.parseInt(slot.trim());
		int final_floor=total_slot/100; 
		use_floor=final_floor;
		int final_slot =total_slot%(100*final_floor);
		use_slot=final_slot;
	//Setting up database connection
		
		Connection conn = null;

		   try
		   {
		       String userName = "root";
		       String password = "";
		       String url = "jdbc:mysql://localhost/parkalot_system";
		       Class.forName ("com.mysql.jdbc.Driver").newInstance ();
		       conn = DriverManager.getConnection (url, userName, password);
		   }
		   catch (Exception e)
		   {
		       System.err.println ("Cannot connect to database server in constructor");
		   }
		   finally
		   {
		       if (conn != null)
		       {
		    	   Statement stmt = null;
		        	 
		           try
		           {	
		        	   //Block user from being used again and also make an entry in database about user's presence in parking lot
		        	   
		        	   	stmt = conn.createStatement();
						stmt. executeUpdate("UPDATE temp_slot set temp_used=1,temp_block=1 where temp_regnum="+arr_regnum);
						
						// To check if reserved slot has already gotten alloted to someone(say someone parked wrongly at the reserved spot)
						// If so, then generate a random slot and allot it to the user
						
						ResultSet rs = stmt.executeQuery("SELECT slot_alloted FROM `use_slot_temp` WHERE slot_number="+arr_slot);
						if(rs.next())
						{
							String slot_status=rs.getString(1);
						    int slot_compare = Integer.parseInt(slot_status.trim());
						    
							if(slot_compare==0)
							{
								stmt. executeUpdate("UPDATE use_slot_temp set slot_alloted=1 where slot_number="+arr_slot);
								stmt. executeUpdate("UPDATE use_slot_temp set slot_regnum_alloted="+arr_regnum+" where slot_number="+arr_slot);
								System.out.println("\n\n\nRegnum "+arr_regnum+" has entered the parking lot parking for slot="+arr_slot);
								//System.out.println("Slot was available");

							}
							
						// Random slot generation as described above
							
							else 
							{
								int temp_slot=random_slot();
								arr_slot = Integer.toString(temp_slot);
								stmt. executeUpdate("UPDATE use_slot_temp set slot_alloted=1 where slot_number="+arr_slot);
								System.out.println("\n\n\nRegnum "+arr_regnum+" has entered the parking lot parking for slot="+arr_slot);
								//System.out.println("Had to change slot since it was alloted");

							}
							
						}
					} 
		           catch (SQLException e1)
		           {
						e1.printStackTrace();
		           }
		    	  
		           try
		           {
		               conn.close ();
		           }
		           catch (Exception e)
		           { 
		           }
		       }
		   	}	
		
		construct_plp(final_slot,final_floor);
		t.start();
		
	}
	
	public void construct_plp(int final_slot,int final_floor)
	{
		actual_path = new Vector<Integer>();
		parking_lot_path= new Vector<Integer>();
		sensor_path= new Vector<Integer>();
		
		//Creating parking_lot_path vector which has all slots in the PL
		for (int i=0;i<=16;i++)
		{
			parking_lot_path.addElement(new Integer(i));
		}
		
		for(int i=34;i<=50;i++)
		{
			parking_lot_path.addElement(new Integer(i));
		}
		
		for(int i=68;i<=84;i++)
		{
			parking_lot_path.addElement(new Integer(i));
		}

		for(int i=85;i<=99;i++)
		{
			parking_lot_path.addElement(new Integer(i));
		}
		
		parking_lot_path.addElement(new Integer(0));

		parking_lot_path.addElement(new Integer(0));
		
		//Calculating parking lot size
		parking_lot_size=parking_lot_path.size();
				
	    for(int i=0;i<parking_lot_size;i++)
	    {
	    	sensor_path.addElement(new Integer(0));
	    }
	    Collections.copy(sensor_path,parking_lot_path);
	    

		//Trimming the latter part of the parking_lot_path vector after the group end of 'final slot'

		int size=(Integer)parking_lot_path.size();


		if(final_slot<17)
		{
			int j=18;
			while(j<size)
			{
				size=(Integer)parking_lot_path.size();
				parking_lot_path.removeElementAt(j-1);
			}
		}
		
		else if(final_slot>=17 && final_slot<51)
		{
			int j=50;
			int last_element=(Integer) parking_lot_path.get(size-1);
			while(j!=last_element)
			{
				parking_lot_path.removeElementAt(size-1);
				//System.out.println("Dynamic path of PLP is"+parking_lot_path);
				size=(Integer)parking_lot_path.size();
				//System.out.println("Size="+size);
				last_element=(Integer) parking_lot_path.get(size-1);
			}
		}

		else if(final_slot>=51 && final_slot<=84)
		{
			int j=84;
			int last_element=(Integer) parking_lot_path.get(size-1);
			while(j!=last_element)
			{
				parking_lot_path.removeElementAt(size-1);
				size=(Integer)parking_lot_path.size();
				last_element=(Integer) parking_lot_path.get(size-1);
			}
		}
		
		else if(final_slot>=85 && final_slot<100)
		{
			parking_lot_path.removeElementAt(size-1);
			size=(Integer) parking_lot_path.size();
			parking_lot_path.removeElementAt(size-1);

		}
		
					
		//Trimming the initial part of the parking_lot_path vector until the 'final slot'
		if(final_slot<17)
		{
			for(int i=0;i<final_slot;i++)
			{
				parking_lot_path.remove(0);

			}
		}
		
		else if((final_slot>=17) && (final_slot<=33))
		{
			int i1=final_slot+17;
			int temp_node=(Integer)parking_lot_path.get(0);
			//System.out.println("i1="+i1);
			if(i1==34)
			{
				while(temp_node!=16)
				{
					//System.out.println("dynamic PLP path="+parking_lot_path);

					temp_node=(Integer)parking_lot_path.get(0);
					parking_lot_path.remove(0);

				}
				
			}
			else
			{
				while(temp_node!=i1-1)
				{
					temp_node=(Integer)parking_lot_path.get(0);
					parking_lot_path.remove(0);
	
				}
			}
		}
		
		
		else if((final_slot>=34) && (final_slot<=50))
		{
			int temp_node=(Integer)parking_lot_path.get(0);

			if(final_slot==34)
			{
				while(temp_node!=16)
				{
					temp_node=(Integer)parking_lot_path.get(0);
					parking_lot_path.remove(0);

				}

			}
			else
			{
				while(temp_node!=final_slot-1)
				{			
					temp_node=(Integer)parking_lot_path.get(0);
					parking_lot_path.remove(0);
	
				}
			}
		}
		
		else if((final_slot>=51) && (final_slot<=67))
		{
			int i1=final_slot+17;
			int temp_node=(Integer)parking_lot_path.get(0);
			if(i1==68)
			{
				while(temp_node!=50)
				{
					temp_node=(Integer)parking_lot_path.get(0);
					parking_lot_path.remove(0);
					//System.out.println("temp node "+temp_node);


				}
				
			}
			else
			{
				while(temp_node!=i1-1)
				{
					temp_node=(Integer)parking_lot_path.get(0);
					parking_lot_path.remove(0);
	
				}
			}
		}
		
		else if((final_slot>=68) && (final_slot<=84))
		{
			
			//System.out.println("PLP is="+parking_lot_path);
			int temp_node=(Integer)parking_lot_path.get(0);
			if(final_slot==68)
			{
				while(temp_node!=50)
				{
					temp_node=(Integer)parking_lot_path.get(0);
					parking_lot_path.remove(0);
					//System.out.println("temp_node="+temp_node);
				}
				
			}
			else
			{
				while(temp_node!=final_slot-1)
				{
					temp_node=(Integer)parking_lot_path.get(0);
					parking_lot_path.remove(0);
	
				}
			}
		}
		
		else if((final_slot>84) && (final_slot<=99))
		{
			
			int temp_node=(Integer)parking_lot_path.get(0);
			if(final_slot==85)
			{
				while(temp_node!=84)
				{
					temp_node=(Integer)parking_lot_path.get(0);
					parking_lot_path.remove(0);

				}
				
			}
			else
			{
				while(temp_node!=final_slot-1)
				{
					temp_node=(Integer)parking_lot_path.get(0);
					parking_lot_path.remove(0);
	
				}
			}
		}
	
		for(int k=final_floor-1;k>=1;k--)
		{
			parking_lot_path.addElement(new Integer(1000*k));
		}
				
		//Reversing vector elements to get the same path direction as sensors  are set off
		
		int final_size=(Integer)parking_lot_path.size();
		parking_lot_path.trimToSize();	
		for(int k=0;k<final_size/2;k++)
		{
			int temp_start= (Integer)parking_lot_path.get(k); 
			int temp_end  = (Integer)parking_lot_path.get(final_size-1-k);
			parking_lot_path.set(k,new Integer(temp_end));
			parking_lot_path.set(final_size-1-k,new Integer(temp_start));
				
		}
		parking_lot_path.add(new Integer (final_slot));
		System.out.println("The reserved slot path is "+parking_lot_path);
	}
	
	public void construct_sp(String arr_regnum, int actual_final_slot, int actual_final_floor)
	{
		//Trimming the latter part of the sensor_path vector after the group end of 'final slot'

		int size=(Integer)sensor_path.size();
		
		if(actual_final_slot<17)
		{
			int j=18;
			while(j<size)
			{
				size=(Integer)sensor_path.size();
				sensor_path.removeElementAt(j-1);
			}
		}

		else if(actual_final_slot<51 && actual_final_slot>16)
		{
			int j=35;
			while(j<size)
			{
				size=(Integer)sensor_path.size();
				sensor_path.removeElementAt(j-1);
			}
		}
		else if(actual_final_slot<85 && actual_final_slot>50)
		{
			int j=52;
			while(j<size)
			{
				size=(Integer)sensor_path.size();
				sensor_path.removeElementAt(j-1);
			}
		}	
		
		else if(actual_final_slot<100 && actual_final_slot>84)
		{
			sensor_path.removeElementAt(size-1);
			size=(Integer) sensor_path.size();
			sensor_path.removeElementAt(size-1);
		}
		
		//Trimming the initial part of the sensor_path vector until the 'final slot'
		
		if(actual_final_slot<17)
		{
			for(int i=0;i<actual_final_slot;i++)
			{
				sensor_path.remove(0);

			}
		}
		else if(actual_final_slot<34 && actual_final_slot>16)
		{
			int i1=actual_final_slot+17;
			int temp_node=(Integer)sensor_path.get(0);
			if(i1==34)
			{
				while(temp_node!=16)
				{
					temp_node=(Integer)sensor_path.get(0);
					sensor_path.remove(0);

				}
			}
			else
			{
				while(temp_node<i1-1)
				{
					temp_node=(Integer)sensor_path.get(0);
					sensor_path.remove(0);
	
				}
			}
		}
		
		else if(actual_final_slot<51 && actual_final_slot>33)
		{
			int temp_node=(Integer)sensor_path.get(0);
			if(actual_final_slot==34)
			{
				while(temp_node!=16)
				{
					temp_node=(Integer)sensor_path.get(0);
					sensor_path.remove(0);

				}
			}
			else
			{
				while(temp_node<actual_final_slot-1)
				{
					temp_node=(Integer)sensor_path.get(0);
					sensor_path.remove(0);
	
				}
			}
		}
		else if(actual_final_slot<68 && actual_final_slot>50)
		{
			int i1=actual_final_slot+17;
			int temp_node=(Integer)sensor_path.get(0);
			if(i1==68)
			{
				while(temp_node!=50)
				{
					temp_node=(Integer)sensor_path.get(0);
					sensor_path.remove(0);

				}
			}
			else
			{
				while(temp_node<i1-1)
				{
					temp_node=(Integer)sensor_path.get(0);
					sensor_path.remove(0);
	
				}
			}
		}
		
		else if(actual_final_slot<85 && actual_final_slot>67)
		{
			int temp_node=(Integer)sensor_path.get(0);
			if(actual_final_slot==68)
			{
				while(temp_node!=50)
				{
					temp_node=(Integer)sensor_path.get(0);
					sensor_path.remove(0);

				}
			}
			else
			{
				while(temp_node<actual_final_slot-1)
				{
					temp_node=(Integer)sensor_path.get(0);
					sensor_path.remove(0);
	
				}
			}
		}
		
		else if(actual_final_slot<100 && actual_final_slot>84)
		{
			int temp_node=(Integer)sensor_path.get(0);

			if(actual_final_slot==85)
			{
				while(temp_node!=84)
				{
					temp_node=(Integer)sensor_path.get(0);
					sensor_path.remove(0);

				}
			}
			else
			{
				while(temp_node<actual_final_slot-1)
				{
					temp_node=(Integer)sensor_path.get(0);
					sensor_path.remove(0);
	
				}
			}
		}
		for(int k=actual_final_floor-1;k>=1;k--)
		{
			sensor_path.addElement(new Integer(1000*k));
		}
		
		//Reversing vector elements to get the same path direction as sensors  are set off
		
		int final_size=(Integer)sensor_path.size();
		sensor_path.trimToSize();	
		for(int k=0;k<final_size/2;k++)
		{
			int temp_start = (Integer)sensor_path.get(k); 
			int temp_end  = (Integer)sensor_path.get(final_size-1-k);
			sensor_path.set(k,new Integer(temp_end));
			sensor_path.set(final_size-1-k,new Integer(temp_start));
				
		}
		sensor_path.add(new Integer (actual_final_slot));
		final_size=final_size+1;
		sensor_path_size = final_size;
		Random generator = new Random();
	   // int r = generator.nextInt(18) + 2;

		int r = 1;
		
	    //Passing crossed sensors to update function to get a real-time list of all sensors crossed
	    
	    int rand = 0;	
	    rand = r;
		double speed=(double) 36/r;

	    System.out.println("Sensor path="+sensor_path);
			for(int i=0;i<final_size;i++)
			{
			    if(changePath==false)
			    {
					int active_slot=(Integer)(sensor_path.get(i));
					if((active_slot%1000)==0)
					{
						try
						{
							Thread.sleep(1000*r);
							Random generatorFailure = new Random();
					        int failureProbability = generatorFailure.nextInt(50)+1;
				        	System.out.println("failure number is "+failureProbability);

					        if(failureProbability!=1)
					        {
					        	construct_ap(arr_regnum,active_slot,actual_final_slot,actual_final_floor,0,speed);
					        }
					        else
					        {
					        	System.out.println("failure node is "+active_slot);
					        }
						} 
						catch (InterruptedException e) 
						{
							e.printStackTrace();
						}
						System.out.println("A floor sensor with time "+r+" for "+arr_regnum);
		
					}
					else
					{
					    double time = 0;
					    time = (2/speed);
					    long time1 = (long)(time*1000);

					    
						System.out.println("Not a floor sensor with time "+time+ " for "+arr_regnum);
						try
						{
							Thread.sleep(time1);
							Random generatorFailure = new Random();
					        int failureProbability = generatorFailure.nextInt(50)+1;
					        if(failureProbability!=1)
					        {
					        	System.out.println("failure number is "+failureProbability);
					        	construct_ap(arr_regnum,active_slot,actual_final_slot,actual_final_floor,0,speed);
					        }
					        else
					        {
					        	System.out.println("failure node is "+active_slot);

					        }
					        
						} 
						catch (InterruptedException e) 
						{
							e.printStackTrace();
						}
					}
			    }
			    
			    else 
			    	break;
			    
			}
				

	    
	    if (changePath==true)
	    {
	    	System.out.println("@@@@@@@@@@There has been a change in FINAL DESTINATION@@@@@@@@@");
	    	modify_current_path(arr_regnum,last_node,max_node,rand);
	    }
	    
	    else
	    {
	    	int actual_stop=(Integer)(sensor_path.get(final_size-1));
			construct_ap(arr_regnum,actual_stop,actual_final_slot,actual_final_floor,1,0);
	    }
	}
	
	public void modify_current_path(String arr_num, int last_node, int max_node, int rand) 
	{		
		modified_path = new Vector<Integer>();
		System.out.println("IN MODIFY_CURRENT_PATH&&&&&&&&&&&&&&&&&&");
		//System.out.println("Current floor is "+max_node+" and current slot is "+last_node);
		Random generator = new Random();
        int r = 0; //generator.nextInt(500)+100;
        int start=0;
        int range=0;
        
		if(max_node==16)
		{
			if(last_node<=16)
			{
				start = 100;
				range = 100 + (last_node); // giving a slot 3 away from the current position
				
			}
			else if (last_node<=50)
			{
				start = 134;
				range = 134 + (last_node); // giving a slot 3 away from the current position
			}
			else if (last_node<=50)
			{
				start = 168;
				range = 168 + (last_node); // giving a slot 3 away from the current position
			}
			else if (last_node<=50)
			{
				start = 185;
				range = 185 + (last_node); // giving a slot 3 away from the current position
			}
			 r = generator.nextInt(range-start)+start;
		}
		else if (max_node==1000)
		{
			if(last_node<=16)
			{
				start = 200;
				range = 200 + (last_node); // giving a slot 3 away from the current position
				
			}
			else if (last_node<=50)
			{
				start = 234;
				range = 234 + (last_node); // giving a slot 3 away from the current position
			}
			else if (last_node<=50)
			{
				start = 268;
				range = 268 + (last_node); // giving a slot 3 away from the current position
			}
			else if (last_node<=50)
			{
				start = 285;
				range = 285 + (last_node); // giving a slot 3 away from the current position
			}
			 r = generator.nextInt(range-start)+start;
		}
		else if (max_node==2000)
		{
			if(last_node<=16)
			{
				start = 300;
				range = 300 + (last_node); // giving a slot 3 away from the current position
				
			}
			else if (last_node<=50)
			{
				start = 334;
				range = 334 + (last_node); // giving a slot 3 away from the current position
			}
			else if (last_node<=50)
			{
				start = 368;
				range = 368 + (last_node); // giving a slot 3 away from the current position
			}
			else if (last_node<=50)
			{
				start = 385;
				range = 385 + (last_node); // giving a slot 3 away from the current position
			}
			 r = generator.nextInt(range-start)+start;
		}
		else if (max_node==3000)
		{
			if(last_node<=16)
			{
				start = 400;
				range = 400 + (last_node); // giving a slot 3 away from the current position
				
			}
			else if (last_node<=50)
			{
				start = 434;
				range = 434 + (last_node); // giving a slot 3 away from the current position
			}
			else if (last_node<=50)
			{
				start = 468;
				range = 468 + (last_node); // giving a slot 3 away from the current position
			}
			else if (last_node<=50)
			{
				start = 485;
				range = 485 + (last_node); // giving a slot 3 away from the current position
			}
			 r = generator.nextInt(range-start)+start;
		}
		else if (max_node==4000)
		{
			if(last_node<=16)
			{
				start = 500;
				range = 500 + (last_node); // giving a slot 3 away from the current position
				
			}
			else if (last_node<=50)
			{
				start = 534;
				range = 534 + (last_node); // giving a slot 3 away from the current position
			}
			else if (last_node<=50)
			{
				start = 568;
				range = 568 + (last_node); // giving a slot 3 away from the current position
			}
			else if (last_node<=50)
			{
				start = 585;
				range = 585 + (last_node); // giving a slot 3 away from the current position
			}
			 r = generator.nextInt(range-start)+start;
		}
    	
		Connection conn = null;

		   try
		   {
		       String userName = "root";
		       String password = "";
		       String url = "jdbc:mysql://localhost/parkalot_system";
		       Class.forName ("com.mysql.jdbc.Driver").newInstance ();
		       conn = DriverManager.getConnection (url, userName, password);
		   }
		   catch (Exception e)
		   {
		       System.err.println ("Cannot connect to database server in random_slot()");
		   }
		   finally
		   {
		       if (conn != null)
		       {
		    	   Statement stmt = null;
		        	 
		           try
		           {	
		        	   	stmt = conn.createStatement();
		        	   	ResultSet rs = stmt.executeQuery("SELECT slot_alloted FROM `use_slot_temp` WHERE slot_number="+r);
						
		        	   	//generate random slot. if slot is occupied, generate another random slot.
		        	   	
						if(rs.next())
						{
							String random_status_1=rs.getString(1);
						    int random_status = Integer.parseInt(random_status_1.trim());
							if (random_status==0)
							{
								stmt. executeUpdate("UPDATE use_slot_temp set slot_alloted=1 where slot_number="+r);
								stmt. executeUpdate("UPDATE use_slot_temp set slot_regnum_alloted="+arr_regnum+" where slot_number="+r);
								
							}
							else 
								random_slot();
						}
						
					} 
		           catch (SQLException e1)
		           {
						e1.printStackTrace();
		           }
		       }
		   }
		   
		   //creating modified path vector
			actual_path = new Vector<Integer>();
			//HACK
			//r=101;
		   int r_floor=r/100;
		   int r_slot=r-(r_floor*100);
		   int current_floor=(max_node/1000)+1;
		   System.out.println("!!!!!!!!!!!!!!!!New slot is "+r_slot);
		   System.out.println("!!!!!!!!!!!!!!!!New floor is "+r_floor);
		   System.out.println("!!!!!!!!!!!!!!!!Current floor is "+current_floor);
		   
		   //detect if last node was a floor sensor or a row sensor and then decide the modified path
		   System.out.println("modified_path="+modified_path);
		   if(last_node%1000!=0)		//Row sensor
		   {
			   if(current_floor == 1 && r_floor == 1 && r_slot < last_node)
			   {
				   if((last_node>=0)&&(last_node<=16))
				   {
					   for(int i=last_node-1;i>=r_slot;i--)
					   {
						   modified_path.add(i);
					   }
					   
				   }
				   
				  				   
				   else  if((last_node>=34)&&(last_node<=50))
				   {
					   for(int i=last_node-1;i>=r_slot;i--)
					   {
						   modified_path.add(i);
					   }
					   
				   } 
				   
				
				   
				   else  if((last_node>=68)&&(last_node<=84))
				   {
					   for(int i=last_node-1;i>=r_slot;i--)
					   {
						   modified_path.add(i);
					   }
					   
				   } 
				   
				   else  if((last_node>=85)&&(last_node<=99))
				   {
					   for(int i=last_node-1;i>=r_slot;i--)
					   {
						   modified_path.add(i);
					   }
					   
				   } 
			   }
			  // else if ((current_floor == r_floor) && ())
			   //{
				   
			  // }
			   else
			   {
			   if((last_node>=0)&&(last_node<=16))
			   {
				   for(int i=last_node-1;i>=0;i--)
				   {
					   modified_path.add(i);
				   }
				   
			   }
			   
			   else  if((last_node>=17)&&(last_node<=33))
			   {
				   for(int i=((last_node-1)+17);i>=34;i--)
				   {
					   modified_path.add(i);
				   }
				   
			   }
			   
			   else  if((last_node>=34)&&(last_node<=50))
			   {
				   for(int i=last_node-1;i>=34;i--)
				   {
					   modified_path.add(i);
				   }
				   
			   } 
			   
			   else  if((last_node>=51)&&(last_node<=67))
			   {
				   for(int i=((last_node-1)+17);i>=68;i--)
				   {
					   modified_path.add(i);
				   }
				   
			   } 
			   
			   else  if((last_node>=68)&&(last_node<=84))
			   {
				   for(int i=last_node-1;i>=68;i--)
				   {
					   modified_path.add(i);
				   }
				   
			   } 
			   
			   else  if((last_node>=85)&&(last_node<=99))
			   {
				   for(int i=last_node-1;i>=85;i--)
				   {
					   modified_path.add(i);
				   }
				   
			   } 
			   
			   
			   if(current_floor<r_floor)//add at beginning
			   {System.out.println("At beginning");
				   for(int j=current_floor;j<r_floor;j++)
				   {
					   modified_path.add(j*1000);
				   }
			   }
			   else if(current_floor>r_floor)//add at end
			   {System.out.println("At end");
				   for(int j=current_floor;j>r_floor;j--)
				   {
					   modified_path.add((j*1000)+1);
				   }
			   }
			   else if(current_floor==r_floor)
			   {	System.out.println("Same floor");
			   		if(current_floor==1)
			   		{
			   			modified_path.add(((1)*1000));
			   			modified_path.add(2001);
			   		}	
			   		else
			   		{
					   modified_path.add(((current_floor-1)*1000));
					   modified_path.add((current_floor*1000)+1);//add at end
				   	}
			   }
			    
			   
			   //Add the row sensors for the particular new final slot
			   
			   if((r_slot>=0)&&(r_slot<=16))
			   {
				   for(int i=16;i>=r_slot;i--)
				   {
					   modified_path.add(i);
				   }
				   modified_path.add(r_slot);
			   }
			   
			   else if((r_slot>=17)&&(r_slot<=33))
			   {
				   for(int i=50;i>=(r_slot+17);i--)
				   {
					   modified_path.add(i);
				   }
				   modified_path.add(r_slot);

				   
			   }
			   
			   else    if((r_slot>=34)&&(r_slot<=50))
			   {
				   for(int i=50;i>=r_slot;i--)
				   {
					   modified_path.add(i);
				   }
				   modified_path.add(r_slot);
			   }
			   
			   else if((r_slot>=51)&&(r_slot<=67))
			   {
				   for(int i=84;i>=r_slot;i--)
				   {
					   modified_path.add(i);
				   }
				   modified_path.add(r_slot);
				   
			   }
			   else if((r_slot>=68)&&(r_slot<=84))
			   {
				   for(int i=84;i>=r_slot;i--)
				   {
					   modified_path.add(i);
				   }
				   modified_path.add(r_slot);
			   }
			   
			   else if((r_slot>=85)&&(r_slot<=99))
			   {
				   for(int i=99;i>=r_slot;i--)
				   {
					   modified_path.add(i);
				   }
				   modified_path.add(r_slot);
			   }
			   
			   }
		   }
		   
		   else						//floor sensor
		   {
			   if(current_floor<r_floor)//add at beginning
			   {
				   for(int j=current_floor;j<r_floor;j++)
				   {
					   modified_path.add(j*1000);
				   }
			   }
			   else if(current_floor>r_floor)//add at end
			   {
				   for(int j=current_floor;j>r_floor;j++)
				   {
					   modified_path.add((j*1000)+1);
				   }
			   }
			   else if(current_floor==r_floor)
			   {
				   modified_path.add((current_floor*1000)+1);//add at end
				   modified_path.add(((current_floor-1)*1000));
			   }
			   
			   //Add the row sensors for the particular new final slot
			   
			   if((r_slot>=0)&&(r_slot<=16))
			   {
				   for(int i=16;i>=r_slot;i--)
				   {
					   modified_path.add(i);
				   }
				   modified_path.add(r_slot);
			   }
			   
			   else if((r_slot>=17)&&(r_slot<=33))
			   {
				   for(int i=50;i>=(r_slot+17);i--)
				   {
					   modified_path.add(i);
				   }
				   modified_path.add(r_slot);

				   
			   }
			   
			   else    if((r_slot>=34)&&(r_slot<=50))
			   {
				   for(int i=50;i>=r_slot;i--)
				   {
					   modified_path.add(i);
				   }
				   modified_path.add(r_slot);
			   }
			   
			   else if((r_slot>=51)&&(r_slot<=67))
			   {
				   for(int i=84;i>=r_slot;i--)
				   {
					   modified_path.add(i);
				   }
				   modified_path.add(r_slot);
				   
			   }
			   else if((r_slot>=68)&&(r_slot<=84))
			   {
				   for(int i=84;i>=r_slot;i--)
				   {
					   modified_path.add(i);
				   }
				   modified_path.add(r_slot);
			   }
			   
			   else if((r_slot>=85)&&(r_slot<=99))
			   {
				   for(int i=99;i>=r_slot;i--)
				   {
					   modified_path.add(i);
				   }
				   modified_path.add(r_slot);
			   }
			   
			   
		   }
		   
		   //Insert the passing for loop here
		   
			int modified_size=(Integer)modified_path.size();
			double speed=(double) 36/rand;
		    System.out.println("VALUE OF MODIFIED SPEED======================="+speed);
		    double time = 0;
		    
		    time = (double) ((2/speed));
			long time1 = (long)(time*1000);

		    System.out.println("modifiied path="+modified_path);
		    System.out.println("modified_size="+modified_size);
			for(int i=0;i<modified_size;i++)
			{	
				System.out.println("*****************Passing Modified Sensor Path********************");
				int active_slot=(Integer)(modified_path.get(i));
				System.out.println("active_slot="+active_slot);
				if((active_slot%1000)==0)
				{
					try
					{
						Thread.sleep(1000*rand);
						construct_ap(arr_regnum,active_slot,r_slot,r_floor,0,speed);
	
					} 
					catch (InterruptedException e) 
					{
						e.printStackTrace();
					}
					System.out.println("A floor sensor with time "+rand+" for "+arr_regnum);
	
				}
				else
				{
				    
	
					System.out.println("Not a floor sensor with time "+time+" for "+arr_regnum);
					try
					{
						Thread.sleep((long)time1*1000);
						System.out.println("Sleep just completed");
						Random generatorFailure = new Random();
				        int failureProbability = generatorFailure.nextInt(50)+1;
				        if(failureProbability!=1)
				        {
				        	System.out.println("failure number is "+failureProbability);
				        	construct_ap(arr_regnum,active_slot,r_slot,r_floor,0,speed);
				        }
					} 
					catch (InterruptedException e) 
					{
						e.printStackTrace();
					}
				}
			}
			int actual_stop=(Integer)(modified_path.get(modified_size-1));
			construct_ap(arr_regnum,actual_stop,r_slot,r_floor,1,speed);

	}

	private void construct_ap(String arr_regnum, int active_slot,int final_slot, int final_floor, int dest_slot, double speed) 
	{
		//Create path vector for actual final position(dynamic)
		int temp=(final_floor*100)+active_slot;
		//System.out.println("temp="+temp);
	
//		if(actual_size>0)
		
		//System.out.println("Dest_slot=="+dest_slot);
		actual_size=(Integer) actual_path.size();

		//dest_slot signifies if the passed slot is the final slot(dest_slot=1) or not(dest_slot=0)
		//if 0 keep adding slots to vector
		//if 1 then make database entry whether parked in the right spot or wrong spot.
		if (dest_slot==0)
		{
			final_size_2=(Integer)parking_lot_path.size();
			System.out.println("PLP PASSED ==========="+parking_lot_path);

			//System.out.println("active slot="+active_slot);
			//System.out.println("actual_path="+actual_path);
		
			try 
			{
				Thread.sleep(186);
			} 
			catch (InterruptedException e) 
			{
				e.printStackTrace();
			}
			System.out.println("PASSED SPEED IS "+speed);
			
			double passingDistance = 1.818;
			double passingSpeed = speed*0.444;
			double passingTime = (passingDistance/passingSpeed)*1000;
			System.out.println("PASSING TIME+==========="+passingTime);
			if(passingTime >= 86)
				actual_path.add(active_slot);
			else
				System.out.println("OOOPPPPPSSSSSSSSSSSSSSSSSSIIIEEEEEEEEEEEEEEEEEEEE******************");
			
			System.out.println("CURRENT_INDEX=========="+currentIndex);
			if(currentIndex+2 < final_size_2)
			{
				int node1 = parking_lot_path.get(currentIndex);
				int node2 = parking_lot_path.get(currentIndex+1);
				int node3 = parking_lot_path.get(currentIndex+2);
				
				if(active_slot == node1 )
				{
						currentIndex = currentIndex+1;
				}
				else if(active_slot == node2 )
				{
						currentIndex = currentIndex+2;
				}
				else if(active_slot == node3 )
				{ 
						currentIndex = currentIndex+3;
				}
				else
				{
					System.out.println("@@@@@!The USER "+arr_regnum+" does not seem to be goiung on the correct path!!!!!");
					wrongPath = 1;
				}
			}
		
			if(currentIndexSensor+2 < sensor_path_size)
			{
				int node1 = sensor_path.get(currentIndexSensor);
				int node2 = sensor_path.get(currentIndexSensor+1);
				int node3 = sensor_path.get(currentIndexSensor+2);
				
				if(active_slot == node1 )
				{
						currentIndexSensor = currentIndexSensor+1;
				}
				else if(active_slot == node2 )
				{
					currentIndexSensor = currentIndexSensor+2;
				}
				else if(active_slot == node3 )
				{ 
					currentIndexSensor = currentIndexSensor+3;
				}
				else
				{
					System.out.println("@@@@@!The USER "+arr_regnum+" SEEMS TO HAVE SENSOR TROUBLES!!!!!");
					//wrongPrediction = 1;
				}
			}
	
	
			System.out.println(actual_path);

			if(actual_size>0)
			{
				last_node=actual_path.get(actual_size-1);
				max_node = Collections.max(actual_path);
			}
			else 
			{
				//last_node=actual_path.get(actual_size);
				//max_node = Collections.max(actual_path);
				actual_size=0;
			}
			
			//System.out.println("Last Node="+last_node);
			//System.out.println("Max Node="+max_node);
			
		}
		
		else if (dest_slot==1)
		{	
			Connection conn = null;

			   try
			   {
			       String userName = "root";
			       String password = "";
			       String url = "jdbc:mysql://localhost/parkalot_system";
			       Class.forName ("com.mysql.jdbc.Driver").newInstance ();
			       conn = DriverManager.getConnection (url, userName, password);
			   }
			   catch (Exception e)
			   {
			       System.err.println ("Cannot connect to database server in random_slot()");
			   }
			   finally
			   {
			       if (conn != null)
			       {
			    	   Statement stmt1 = null;
			        	 
			           try
			           {	
			        	   	stmt1 = conn.createStatement();
							//System.out.println("Actual_size="+actual_size);
							//System.out.println("Final Size 2="+final_size_2);
							//if(actual_size!=final_size_2)
			        	   //	actual_size++;
			        	   	
				        	   	System.out.println("actual_size="+actual_size);
				        	   	stmt1. executeUpdate("UPDATE use_slot_temp set slot_overbook="+actual_size+"+ slot_overbook where slot_number="+100);
				        	   	System.out.println("PLP size="+final_size_2);
				        	   	if(actual_size>0)
				        	   		System.out.println("last in actual path="+actual_path.get(actual_size-1));
				        		System.out.println("last in PLP path="+parking_lot_path.get(final_size_2-1));
				        		
				        		int a = 0;
				        		
				        		if(actual_size>0)
				        			a = actual_path.get(actual_size-1);
				        		
				        		int b = parking_lot_path.get(final_size_2-1); 
				        	   	if( a != b)
				        	   	{
				        	   		wrongPath = 1;
				        	   		System.out.println("Last nodes dont match");
				        	   	}
				        	   		
				        	   	int c = sensor_path.get(sensor_path_size-1);
				        	   	if(a != c)
				        	   	{
				        	   		wrongPrediction = 1;
				        	   	} 
				        	   	
				        	   	System.out.println("actual size = "+actual_size);
				        	   	System.out.println("sensor size = "+sensor_path_size);
				        	   	
				        	   	if(actual_size<=((9*(sensor_path_size))/10))
				        	   		wrongPrediction = 1;
				        	   	
				        	   	if(wrongPath == 1)
								{
									System.out.println("User "+arr_regnum+" has parked in the wrong spot!");
									stmt1. executeUpdate("UPDATE use_slot_temp set slot_alloted=1 where slot_number="+temp);
									stmt1. executeUpdate("UPDATE use_slot_temp set slot_alloted=0 where slot_number="+arr_slot);
									stmt1. executeUpdate("UPDATE use_slot_temp set slot_regnum_alloted=0 where slot_number="+arr_slot);
									stmt1. executeUpdate("UPDATE use_slot_temp set slot_status='Occupied' where slot_number="+temp);
									stmt1. executeUpdate("UPDATE use_slot_temp set slot_regnum="+arr_regnum+" where slot_number="+temp);
									stmt1. executeUpdate("UPDATE temp_slot set slot_sensor="+wrongPrediction+" where temp_regnum="+arr_regnum);
									stmt1. executeUpdate("UPDATE use_slot_temp SET slot_wrong = slot_wrong+1 Where slot_number = 100");
	
									
									ResultSet get_1 = stmt1.executeQuery("SELECT slot_regnum_alloted FROM `use_slot_temp` WHERE slot_number="+temp);
									System.out.println("The ROGUE slot is "+temp);				        	   	
									if(get_1.next())
									{
										String alloted_regnum=get_1.getString(1);
										System.out.println("The ROGUE REGNUM is "+alloted_regnum);
										if(alloted_regnum=="")
										{
											System.out.println("ROGUEEEEEEEEEEEEEEEEEEEEEEEe");
	
										}
									    int k = Integer.parseInt(alloted_regnum.trim());
									    System.out.println("k="+k);
									    if(k>0)
									    {
											ResultSet get_2 = stmt1.executeQuery("SELECT slot_regnum FROM `use_slot_temp` WHERE slot_number="+temp);
											if(get_2.next())
											{
												String parked_regnum=get_2.getString(1);
											    int m = Integer.parseInt(parked_regnum.trim());
											    if(m!=k)
											    {
											    	//No. of wrong bookings can be counted here
											    	if(parent.containsKey(alloted_regnum))
											    	{
											    		System.out.println("It does contain");
												    	matrix_new_arrival niceGuy = parent.get(alloted_regnum);
												    	int new_number=100;
												    	System.out.println("Calling the niceGuy from "+arr_regnum+" for slot "+m);
												    	niceGuy.informNiceGuy(new_number,niceGuy);
											    	}
											    	else
											    	{
											    		System.out.println("It does not contain ");
											    	}										    		
											    }
											    else
											    {
											    	
											    }
											    
											}
	
	
									    }
									    else
									    {
									    	
									    }
	
									}
								}
								else
								{
								//	for(int comp=0;comp<actual_size;comp++)
								//	{
							//			count_size++;
						//				int temp_a=(Integer)actual_path.get(comp);
					//					int temp_b=(Integer)parking_lot_path.get(comp);
						
										//if((temp_a==temp_b)&&(final_floor==use_floor) && (random_index==0))
									//	{
										//	if(count_size==actual_size)
								//	{
										System.out.println("User "+arr_regnum+" has parked in the correct spot!");
										stmt1. executeUpdate("UPDATE use_slot_temp set slot_status='Occupied' where slot_number="+arr_slot);
										stmt1. executeUpdate("UPDATE use_slot_temp set slot_regnum="+arr_regnum+" where slot_number="+arr_slot);
										stmt1. executeUpdate("UPDATE use_slot_temp SET slot_right = slot_right+1 Where slot_number = 100");
	
												//break;
											//}
											//else
											//continue;
										//}
									/*	else
										{
											
											System.out.println("User "+arr_regnum+" has parked in the wrong spot!");
											stmt1. executeUpdate("UPDATE use_slot_temp set slot_alloted=1 where slot_number="+temp);
											stmt1. executeUpdate("UPDATE use_slot_temp set slot_alloted=0 where slot_number="+arr_slot);
											stmt1.executeUpdate("UPDATE use_slot_temp set slot_regnum_alloted=0 where slot_number="+arr_slot);
											stmt1. executeUpdate("UPDATE use_slot_temp set slot_status='Occupied' where slot_number="+temp);
											stmt1. executeUpdate("UPDATE use_slot_temp set slot_regnum="+arr_regnum+" where slot_number="+temp);
											stmt1. executeUpdate("UPDATE use_slot_temp SET slot_wrong = slot_wrong+1 Where slot_number = 100");
	
										//	break;
										}*/
								//	}
						
								}
				           
			           } 
			           catch (SQLException e1)
			           {
							e1.printStackTrace();
			           }
			       }
			   }
		}
	} 
	
	public void run() 
	{
		int final_random_slot_total=0; 
		final_random_slot_total=random_slot();
		/*int tempa=Integer.parseInt(arr_regnum);
		if(tempa==10000)
		final_random_slot_total=101;
		if(tempa==10001)
			final_random_slot_total=101;
		*/
		Connection conn = null;

		   try
		   {
		       String userName = "root";
		       String password = "";
		       String url = "jdbc:mysql://localhost/parkalot_system";
		       Class.forName ("com.mysql.jdbc.Driver").newInstance ();
		       conn = DriverManager.getConnection (url, userName, password);
		   }
		   catch (Exception e)
		   {
		       System.err.println ("Cannot connect to database server in random_slot()");
		   }
		   finally
		   {
		       if (conn != null)
		       {
		    	   Statement stmt = null;
		        	 
		           try
		           {	
		        	   	stmt = conn.createStatement();
		        	   	stmt.executeUpdate("UPDATE temp_slot set slot_parked="+ final_random_slot_total +" WHERE temp_regnum="+arr_regnum);
		           }
		           
		           catch (SQLException e1)
		           {
						e1.printStackTrace();
		           }
		       }
		   }
		   
		System.out.println("Random slot  passed as final destination is = "+final_random_slot_total);
		int final_random_floor=final_random_slot_total/100;
		int final_random_slot=final_random_slot_total%(100*final_random_floor);
		construct_sp(arr_regnum,final_random_slot,final_random_floor);
	}
	
	public int random_slot()
	{
		
		//choice variable is used to give a 50% probability that the user will park in his reserved spot or park in a random wrong spot
		//if choice[0], then user parks in designated spot else user parks in random wrong spot
		
		choice=new int [4];
		choice[0]=total_slot;
		
		
    	Random generator = new Random();
        int r = generator.nextInt(500)+100;
		Connection conn = null;

		   try
		   {
		       String userName = "root";
		       String password = "";
		       String url = "jdbc:mysql://localhost/parkalot_system";
		       Class.forName ("com.mysql.jdbc.Driver").newInstance ();
		       conn = DriverManager.getConnection (url, userName, password);
		   }
		   catch (Exception e)
		   {
		       System.err.println ("Cannot connect to database server in random_slot()");
		   }
		   finally
		   {
		       if (conn != null)
		       {
		    	   Statement stmt = null;
		        	 
		           try
		           {	
		        	   	stmt = conn.createStatement();
		        	   	ResultSet rs = stmt.executeQuery("SELECT slot_alloted FROM `use_slot_temp` WHERE slot_number="+r);
						
		        	   	//generate random slot. if slot is occupied, generate another random slot.
		        	   	
						if(rs.next())
						{
							String random_status_1 = rs.getString(1);
						    int random_status = Integer.parseInt(random_status_1.trim());
							if (random_status == 0)
							{
								choice[1] = r;
								//choice[2] = r;
								//choice[3] = r;
							}
							else 
								random_slot();
						}
				        random_index = generator.nextInt(2)+0;
				        //System.out.println("random_index="+random_index);
				        //System.out.println("choice="+choice[random_index]);
				        //System.out.println("arr_regnum="+arr_regnum);
				      //  stmt.executeUpdate("UPDATE use_slot_temp set slot_regnum_alloted="+arr_regnum+ " WHERE slot_number="+choice[random_index]);
					} 
		           catch (SQLException e1)
		           {
						e1.printStackTrace();
		           }
	        	/*   try 
	        	   {
	        		//   stmt.executeUpdate("UPDATE use_slot_temp set slot_regnum_alloted="+arr_regnum+ "WHERE slot_number="+choice[random_index]);
	        	   } 
	        	   catch (SQLException e) 
	        	   {
						// TODO Auto-generated catch block
						e.printStackTrace();
	        	   }*/

		       }
		   }
			return(choice[random_index]);
	}

	public void informNiceGuy(int new_number, matrix_new_arrival niceGuy)
{
	System.out.println(this);
	System.out.println("#####################################That special case has been reached");
	//niceGuy.t.sleep(10000);
	//t.sleep(1000);
	changePath = true;
	//niceGuy.
	System.out.println("FInished SLepepingafaf@@@@@@@@@@@@@@@@@"+this.arr_regnum);
	System.out.println("changePath for "+arr_regnum+ "is "+changePath);
	
}

}

