import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;

public class Track_2_control 
{
	public static void main (String args []) 
	{	
		
		//Arrival Thread Variable initialization
		
		String arrival_thread_regnum="";
		String final_slot="";
        HashMap<String,Track_2> hashMap = new HashMap<String,Track_2>();

		
		//Setting up database connection
		
		Connection conn = null;

        try
        {
            String userName = "root";
            String password = "";
            String url = "jdbc:mysql://localhost/parkalot_system";
            Class.forName ("com.mysql.jdbc.Driver").newInstance ();
            conn = DriverManager.getConnection (url, userName, password);
        }
        catch (Exception e)
        {
            System.err.println ("Cannot connect to database server");
        }
        finally
        {
            if (conn != null)
            { 
            	Statement stmt = null;
            	int answer=1;
		               try
		               {
		            	   while(answer==1)
		            	   {
							stmt = conn.createStatement();
							
							//Selecting a slot which is vacant and has not been alloted yet. This will then be alloted to the next incoming user.

							ResultSet rs = stmt.executeQuery("SELECT slot_number FROM `use_slot_temp` WHERE slot_status = 'Vacant' and slot_alloted=0");

							if(rs.next())
							{
								final_slot=rs.getString(1);

							//Selecting a user randomly from the user table such that he is not in the parking lot and has not been used till now.
								ResultSet rs1 = stmt.executeQuery("SELECT MIN(temp_regnum) FROM temp_slot where temp_used='0' and temp_block='0' and temp_regnum<10500");
								if (rs1.next())
								{
									arrival_thread_regnum = rs1.getString(1);
									
							//Calling thread for each new user and sending his registration number and advance reservation spot number
									
									Track_2 temp = new Track_2(hashMap, arrival_thread_regnum,final_slot);
									
									hashMap.put(new String(arrival_thread_regnum),temp);

									try 
									{
										Thread.sleep(10000);
									} 
									catch (InterruptedException e) 
									{
										e.printStackTrace();
									}								
								}
								else
									System.out.println("No more users available to simulate the arrival threads");
							 }
		            	   }	
	            	   
		               }
		               catch (SQLException e1)
		               {
							e1.printStackTrace();
		               }

            		}
        	}
        System.out.println("Exiting Main");
 	}

}
